<?php


namespace Repository;

use Doctrine\ORM\EntityManager;
use Util\InstanceProvider;
use Zeedhi\DevOps\Model\Traits\TQuery;

class Comments extends RepositoryBase
{

    use TQuery;

    const ENTITY_NAME = '\Zeedhi\DevOps\Model\Projectmanagement\Entities\Comments';
    /**
     * @var EntityManager
     */
    private $entityManager;

    public function __construct()
    {
        parent::__construct(self::ENTITY_NAME);
        $this->entityManager = InstanceProvider::getEntityManager();
    }

    public function getCommentsOfTaskExceptCommentedBy($issueId) {
        $query = "
            SELECT *
              FROM (SELECT C.ID, C.ORGANIZATION, C.DESCRIPTION, TO_CHAR(C.CREATED_AT, 'DD/MM/YYYY HH24:MI:SS') AS CREATED_AT, C.TASK, C.CREATED_BY, R.NAME AS CREATED_BY_NAME,
                           'Criado dia '||TO_CHAR(C.CREATED_AT, 'DD/MON/YYYY ','NLS_LANGUAGE = BRAZILIAN PORTUGUESE')||' por '||R.NAME AS NAME,
                           TO_CHAR(C.CREATED_AT, 'YYYYMMDDHH24MISS') AS ORDERBY
                      FROM COMMENTS C
                 LEFT JOIN RESOURCE_T R ON(R.ID = C.CREATED_BY)
                     WHERE C.TASK = :TASK_ID)
          ORDER BY ORDERBY DESC";

        $params = array(
            'TASK_ID' => $issueId
        );

        return $this->entityManager->getConnection()->fetchAll($query, $params);
    }

}
