/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8420_SUPSTPS.sql

Descrição:
- Insere os dados selecionados para Apurao/Efetivao
- Atualiza os produtos a comprar
- Atualiza as quantidades a comprar para os produtos j apurados

Criao:
01/06/2000 - Adriano de Arajo
*/

IF EXISTS (SELECT *
             FROM SYSOBJECTS O, SYSUSERS U
            WHERE O.NAME = 'APURA_EFETIVACAO'
              AND TYPE = 'P'
              AND U.UID = O.UID
              AND U.NAME = USER)
   DROP PROCEDURE APURA_EFETIVACAO;
GO

CREATE PROCEDURE APURA_EFETIVACAO
   @P_CDCENTCMP        VARCHAR(4),
   @P_NRSEQAPUR        VARCHAR(10),
   @P_PRODINI          VARCHAR(20) = NULL,
   @P_PRODFIN          VARCHAR(20) = NULL,
   @P_DTINI            DATETIME,
   @P_DTFIN            DATETIME,
   @P_CDOPERADOR       VARCHAR(12),
   @P_CDREGIAO         VARCHAR(2000) = NULL,
   @P_CDFILIAL         VARCHAR(4),
   @P_DTPROCESSA       DATETIME,
   @P_FILIPROC         VARCHAR(4),
   @P_CDGRUPFILI       VARCHAR(2000) = NULL,
   @P_OPTIMIZER_MODE   VARCHAR(6) = 'CHOOSE',
   @P_ROWSAFFECT       VARCHAR(1) OUTPUT,
   @P_CDOPERLANC       VARCHAR(12),
   @P_CDCOMPRADOR      VARCHAR(12),
   @P_LISTAFILIAL      VARCHAR(2000) = NULL,
   @P_EXTRA            VARCHAR(1),
   @P_IDQTFRAC         VARCHAR(1) = 'N',
   @P_IDUTLITEMRUPTURA VARCHAR(1) = 'N'
AS
   DECLARE @V_TREGIAO           VARCHAR(1);
   DECLARE @V_TGRUPFILI         VARCHAR(1);
   DECLARE @V_QTACOMPRAR        NUMERIC(10, 3);
   DECLARE @V_QTACOMPRAR_AUX    NUMERIC(10, 3);
   DECLARE @V_QTDECOMP          NUMERIC(10, 3);
   DECLARE @V_EXISTAPUR         INT;
   DECLARE @V_PRODINI           VARCHAR(30);
   DECLARE @V_PRODFIN           VARCHAR(30);
   DECLARE @V_CDARVPROD         VARCHAR(10);
   DECLARE @V_CDOPERINI         VARCHAR(12);
   DECLARE @V_CDOPERFIN         VARCHAR(12);
   DECLARE @V_ITEM              VARCHAR(1);
   DECLARE @V_CTPRODATIV        INT;
   DECLARE @V_CTPRODCMP         INT;
   DECLARE @V_CTIMPOSTO         INT;
   DECLARE @V_VRARREDCMP        FLOAT;
   DECLARE @V_IDPRODWEB         VARCHAR(1);
   DECLARE @V_IDAFOPERLOG       VARCHAR(1);
   DECLARE @V_IDCONSPRSOL       VARCHAR(1);
   DECLARE @V_VRARREDEMPE       FLOAT;
   DECLARE @V_CDEMPRESA         VARCHAR(2);
   DECLARE @V_CONCKEY           VARCHAR(200);
   DECLARE @V_IDTIPEMIT         VARCHAR(1);
   DECLARE @V_EMITENTE          VARCHAR(4);
   DECLARE @V_DSPZOPGTCONC      VARCHAR(2000);
   DECLARE @V_IDUTISTATCOT      VARCHAR(1);
   DECLARE @V_IDUTQTDISPGERAL   VARCHAR(1);

   DECLARE @V_LISTA_GRUPFILI    VARCHAR(20);  
   DECLARE @V_LISTA_FILIAL      VARCHAR(20);  
   DECLARE @V_LISTA_REGIAO      VARCHAR(20);  

   DECLARE @V_REGIAO_AUX        VARCHAR(2000);  
   DECLARE @V_GRUPFILI_AUX      VARCHAR(2000);  
   DECLARE @V_FILIAL_AUX        VARCHAR(2000);  

   DECLARE @V_AUX_LISTA         VARCHAR(2000);
   DECLARE @V_IDSEPAFIMP        VARCHAR(1);
   DECLARE @V_CDFILIOPELOG      VARCHAR(2000);
   DECLARE @V_CDFORNOPELOG      VARCHAR(2000);
   DECLARE @V_IDPRODATIV        VARCHAR(1);
   DECLARE @V_IDUTILCONSSOLIOL  VARCHAR(1);
   DECLARE @V_COUNT             DOUBLE PRECISION;

   DECLARE @V_IDUTLMARPREFOL    VARCHAR(1);
   DECLARE @V_CDMARCA_PADRAO    VARCHAR(5);
   DECLARE @V_IDUTLPRARVOLCMP   VARCHAR(1);
   DECLARE @V_IDFUNCAOFILICMPOL VARCHAR(1);
   
   DECLARE @C_FILGRUPFILI_CDFILIAL      VARCHAR(4);
   DECLARE @C_FILGRUPFILI_IDFUNCAOFILI  VARCHAR(1);
   
   DECLARE @C_ITEMSOLI_CDPRODESTO  VARCHAR(10);
   DECLARE @C_ITEMSOLI_CDFILSOLI   VARCHAR(04);
   DECLARE @C_ITEMSOLI_DTPROGENTR  DATETIME;
   DECLARE @C_ITEMSOLI_CDREGIAO    VARCHAR(03);
   DECLARE @C_ITEMSOLI_CDMARCA     VARCHAR(05);
   DECLARE @C_ITEMSOLI_QTDEACOMP   NUMERIC(10, 3);
   
   DECLARE @C_ACORDO_CDFILIAP     VARCHAR(4);
   DECLARE @C_ACORDO_CDPRODITMAP  VARCHAR(10);
   DECLARE @C_ACORDO_CDCENTITMAP  VARCHAR(4);
   DECLARE @C_ACORDO_NRCOLEITMAP  VARCHAR(10);
   DECLARE @C_ACORDO_NRSEQITMAP   VARCHAR(10); 
   DECLARE @C_ACORDO_CDREGITMAP   VARCHAR(3);
   DECLARE @C_ACORDO_CDFORNITMAP  VARCHAR(21);
   DECLARE @C_ACORDO_DTENTRAPUT   DATETIME;
   DECLARE @C_ACORDO_CDMARCITMAP  VARCHAR(5);
   
   DECLARE @C_GRAVA_CDFILIAL      VARCHAR(4);
   DECLARE @C_GRAVA_CDPRODUTO     VARCHAR(10);
   DECLARE @C_GRAVA_VRFATOCONV    DOUBLE PRECISION;
   DECLARE @C_GRAVA_NRCOLEPRECO   VARCHAR(10);
   DECLARE @C_GRAVA_CDFORNECED    VARCHAR(21);
   DECLARE @C_GRAVA_CDREGIAO      VARCHAR(3);
   DECLARE @C_GRAVA_CDMARCA       VARCHAR(5);
   DECLARE @C_GRAVA_CDTIPCOB      VARCHAR(2);
   DECLARE @C_GRAVA_CDFORMPGTO    VARCHAR(2);
   DECLARE @C_GRAVA_IDUTDIAPGCOL  VARCHAR(1);
   DECLARE @C_GRAVA_IDTPFOPGTCOL  VARCHAR(1);
   DECLARE @C_GRAVA_IDTIPFREITM   VARCHAR(1);
   DECLARE @C_GRAVA_NRPARCPGTCOL  NUMERIC;
   DECLARE @C_GRAVA_CDSEGMARCCOL  VARCHAR(5);
   DECLARE @C_GRAVA_VRPRECUNIITM  DOUBLE PRECISION;
   DECLARE @C_GRAVA_VRPERDESITM   DOUBLE PRECISION;
   DECLARE @C_GRAVA_NRDIAPGFXCOL  NUMERIC;
   DECLARE @C_GRAVA_VRPRECECOITM  DOUBLE PRECISION;
   DECLARE @C_GRAVA_VRPRECOITMPI  FLOAT;
   DECLARE @C_GRAVA_IDITMLISPREC  VARCHAR(1);
   DECLARE @C_GRAVA_NRSEQPRELIST  VARCHAR(10);
      
   DECLARE @V_NRPGTCOLCAR         VARCHAR(1000);
   DECLARE @V_PZO_PGTO_NRPZOPGT   VARCHAR(03);
   DECLARE @V_PZO_PGTO_VRPERPGT   VARCHAR(50);

   DECLARE @V_IDARREDCMPAMENOS    VARCHAR(1);
BEGIN
   SET @P_ROWSAFFECT = 'N';
   SET @V_QTACOMPRAR = 0;
   
   IF @P_CDREGIAO IS NULL BEGIN
      SET @V_TREGIAO = 'T';
   END;

   IF @P_CDGRUPFILI IS NULL BEGIN
      SET @V_TGRUPFILI = 'T';
   END
   ELSE BEGIN
      SET @V_TGRUPFILI = 'X';
   END;
   
   IF (@P_PRODINI IS NULL) AND (@P_PRODFIN IS NULL) BEGIN
      SET @V_PRODINI = '0';
      SET @V_PRODFIN = 'ZZZZZZZZZZZZZZZZZZZZ';
   END
   ELSE BEGIN
      IF @P_PRODINI > @P_PRODFIN BEGIN
         SET @V_PRODINI = @P_PRODINI + 'ZZZZZZZZZZ';
         SET @V_PRODFIN = @P_PRODFIN;
      END
      ELSE BEGIN
         SET @V_PRODFIN = @P_PRODFIN + 'ZZZZZZZZZZ';
         SET @V_PRODINI = @P_PRODINI;
      END;
   END;
   
   IF @P_CDOPERADOR = 'T' BEGIN
      SET @V_CDOPERINI = '0';
      SET @V_CDOPERFIN = '999999999999';
      SET @V_ITEM = 'S';
   END
   ELSE BEGIN
      SET @V_CDOPERINI = @P_CDOPERADOR;
      SET @V_CDOPERFIN = @P_CDOPERADOR;
      SET @V_ITEM = 'T';
   END;

   SELECT @V_CDMARCA_PADRAO = MAX(CDMARCA) 
     FROM MARCA;

   SELECT @V_IDCONSPRSOL      = ISNULL(MAX(IDCONSPRSOL), 'N'),     
          @V_IDSEPAFIMP       = ISNULL(MAX(IDSEPAFIMP), 'N'),      
          @V_IDUTISTATCOT     = ISNULL(MAX(IDUTISTATCOT), 'N'),    
          @V_IDUTILCONSSOLIOL = ISNULL(MAX(IDUTILCONSSOLIOL), 'N'),
          @V_IDUTQTDISPGERAL  = ISNULL(MAX(IDUTQTDISPGERAL), 'N'), 
          @V_IDUTLMARPREFOL   = ISNULL(MAX(IDUTLMARPREFOL), 'N'),  
          @V_CDMARCA_PADRAO   = ISNULL(MAX(CDMARCA), @V_CDMARCA_PADRAO),
          @V_IDUTLPRARVOLCMP  = ISNULL(MAX(IDUTLPRARVOLCMP), 'N'),
          @V_IDARREDCMPAMENOS = ISNULL(MAX(IDARREDCMPAMENOS), 'N') /* Grava quantidade a comprar com valor arredondado para menos */
     FROM PARASUPRI
    WHERE CDFILIAL = @P_CDCENTCMP;

   IF @P_IDQTFRAC = 'N' BEGIN
      INSERT INTO APURPRECO
          (CDFILCENTCMP, NRAPURPREC, CDCOMPRADOR, DTINIAPUPREC,
           DTFINAPUPREC, IDSITAPUPREC, DTAPURPREC,CDOPERADOR, CDFILLANC,
           DSGRUPFILIAPUR, CDPRODINICAPUR, CDPRODFINAAPUR, IDCONSOLAPUEFET)
      VALUES
          (@P_CDCENTCMP, @P_NRSEQAPUR, @P_CDCOMPRADOR, @P_DTINI,
           @P_DTFIN, '1', GETDATE(), @P_CDOPERLANC, @P_FILIPROC,
           @P_CDGRUPFILI, @P_PRODINI, @P_PRODFIN, @P_EXTRA);
   END
   ELSE BEGIN
     DELETE FROM ITMAPURPREC
      WHERE CDCENTITMAP = @P_CDCENTCMP
        AND NRSEQITMAP  = @P_NRSEQAPUR;
   END;   

   EXEC TEKNISA.NOVO_CODIGO 'LISTA', @P_SEQUENCIAL = @V_LISTA_GRUPFILI OUTPUT, @P_QTDE = 1;
   SET @V_LISTA_GRUPFILI = SUBSTRING(@V_LISTA_GRUPFILI, 11, 10);

   EXEC TEKNISA.NOVO_CODIGO 'LISTA', @P_SEQUENCIAL = @V_LISTA_FILIAL OUTPUT, @P_QTDE = 1;
   SET @V_LISTA_FILIAL = SUBSTRING(@V_LISTA_FILIAL, 11, 20);

   EXEC TEKNISA.NOVO_CODIGO 'LISTA', @P_SEQUENCIAL = @V_LISTA_REGIAO OUTPUT, @P_QTDE = 1;
   SET @V_LISTA_REGIAO = SUBSTRING(@V_LISTA_REGIAO, 11, 10);

   IF NOT (@V_TGRUPFILI = 'T') BEGIN
      SET @V_GRUPFILI_AUX = SUBSTRING(@P_CDGRUPFILI, 2, LEN(@P_CDGRUPFILI));
      WHILE CHARINDEX('_',@V_GRUPFILI_AUX) > 0 BEGIN
         SET @V_AUX_LISTA = SUBSTRING(@V_GRUPFILI_AUX, 1, CHARINDEX('_',@V_GRUPFILI_AUX) - 1);
         SET @V_GRUPFILI_AUX = SUBSTRING(@V_GRUPFILI_AUX, CHARINDEX('_',@V_GRUPFILI_AUX) + 1, LEN(@V_GRUPFILI_AUX));

         INSERT INTO LISTA (NRLISTA, CDLISTA)
                    VALUES (@V_LISTA_GRUPFILI, @V_AUX_LISTA);
      END;
   END;

   IF NOT @P_CDFILIAL = 'T' BEGIN
      INSERT INTO LISTA (NRLISTA, CDLISTA)
                 VALUES (@V_LISTA_FILIAL, @P_CDFILIAL);
   END
   ELSE BEGIN
      IF NOT @P_LISTAFILIAL = 'T' BEGIN
         SET @V_FILIAL_AUX = SUBSTRING(@P_LISTAFILIAL, 2, LEN(@P_LISTAFILIAL));
         WHILE CHARINDEX('_', @V_FILIAL_AUX) > 0 BEGIN
            SET @V_AUX_LISTA = SUBSTRING(@V_FILIAL_AUX, 1, CHARINDEX('_',@V_FILIAL_AUX) - 1);
            SET @V_FILIAL_AUX = SUBSTRING(@V_FILIAL_AUX, CHARINDEX('_',@V_FILIAL_AUX) + 1, LEN(@V_FILIAL_AUX));
            
            INSERT INTO LISTA (NRLISTA, CDLISTA)
                       VALUES (@V_LISTA_FILIAL, @V_AUX_LISTA);
         END;
      END;
   END;

   IF @V_TREGIAO = 'T' BEGIN
      INSERT INTO LISTA (NRLISTA, CDLISTA)
        SELECT @V_LISTA_REGIAO, CDREGIAO
          FROM REGIAO;
   END
   ELSE BEGIN
      SET @V_REGIAO_AUX = SUBSTRING(@P_CDREGIAO, 2, LEN(@P_CDREGIAO));
      WHILE CHARINDEX('_',@V_REGIAO_AUX) > 0 BEGIN
         SET @V_AUX_LISTA = SUBSTRING(@V_REGIAO_AUX, 1, CHARINDEX('_',@V_REGIAO_AUX) - 1);
         SET @V_REGIAO_AUX = SUBSTRING(@V_REGIAO_AUX, CHARINDEX('_',@V_REGIAO_AUX) + 1, LEN(@V_REGIAO_AUX));
         INSERT INTO LISTA (NRLISTA, CDLISTA)
                    VALUES (@V_LISTA_REGIAO, @V_AUX_LISTA);
      END;
   END;

   DECLARE C_FILGRUPFILI CURSOR FOR
      SELECT FILGRUPFILI.CDFILIAL, ISNULL(FILIAL.IDFUNCAOFILI, 'NULL') IDFUNCAOFILI
        FROM LISTA INNER JOIN FILGRUPFILI ON LISTA.CDLISTA = FILGRUPFILI.CDGRUPFILI
                   INNER JOIN FILIAL ON FILIAL.CDFILIAL = FILGRUPFILI.CDFILIAL
       WHERE LISTA.NRLISTA = @V_LISTA_GRUPFILI
         AND EXISTS(SELECT '1'
                      FROM SOLICITA
                     WHERE SOLICITA.CDFILSOLI = FILGRUPFILI.CDFILIAL)
         AND ((@P_LISTAFILIAL = 'T') OR EXISTS(SELECT 1
                                                 FROM LISTA
                                                WHERE LISTA.NRLISTA = @V_LISTA_FILIAL
                                                  AND LISTA.CDLISTA = FILIAL.CDFILIAL))

       UNION

      SELECT FILIAL.CDFILIAL, ISNULL(FILIAL.IDFUNCAOFILI, 'NULL') IDFUNCAOFILI
        FROM FILIAL
       WHERE @V_TGRUPFILI = 'T'
         AND EXISTS(SELECT '1'
                      FROM SOLICITA
                     WHERE SOLICITA.CDFILSOLI = FILIAL.CDFILIAL)
         AND ((@P_LISTAFILIAL = 'T') OR EXISTS(SELECT 1
                                                 FROM LISTA
                                                WHERE LISTA.NRLISTA = @V_LISTA_FILIAL
                                                  AND LISTA.CDLISTA = FILIAL.CDFILIAL));

   OPEN C_FILGRUPFILI;
   FETCH NEXT FROM C_FILGRUPFILI INTO @C_FILGRUPFILI_CDFILIAL, @C_FILGRUPFILI_IDFUNCAOFILI;
   WHILE (@@FETCH_STATUS = 0) BEGIN

      INSERT INTO PRODCMPFILI_TMP (NRSEQAPUR, CDFILIAL, CDPRODUTO)
           SELECT @P_NRSEQAPUR AS NRSEQAPUR, CDFILIAL, CDPRODUTO
             FROM PRODCMPFILI
            WHERE CDFILIAL = @C_FILGRUPFILI_CDFILIAL;

      SET @V_IDFUNCAOFILICMPOL = 'N';

      IF (@C_FILGRUPFILI_IDFUNCAOFILI = 'O') AND (@V_IDUTLPRARVOLCMP = 'S') BEGIN
         SET @V_IDFUNCAOFILICMPOL = 'S';
      END;

      IF (ISNULL(@V_IDCONSPRSOL, 'N') = 'N') AND ((@C_FILGRUPFILI_IDFUNCAOFILI <> 'O')
         OR (@V_IDUTILCONSSOLIOL = 'N')  OR (@V_IDFUNCAOFILICMPOL = 'S')) BEGIN

         DECLARE C_ITEMSOLI CURSOR FOR
            SELECT CASE @V_IDFUNCAOFILICMPOL WHEN 'N'
                     THEN PRODUTO.CDPRODESTO
                     ELSE PRODUTO.CDPRODUTO
                   END CDPRODESTO, ITEMSOLI.CDFILSOLI, ITEMSOLI.DTPROGENTR,
                   FILIAL.CDREGIAO, CASE WHEN @C_FILGRUPFILI_IDFUNCAOFILI = 'O'
                                         THEN ISNULL(ITEMSOLI.CDMARCA, @V_CDMARCA_PADRAO)
                                         ELSE NULL
                                    END CDMARCA,
                   SUM(ISNULL(ITEMSOLI.QTSOLIPROD*PRODUTO.VRFATOCONV, 0)) AS QTDEACOMP 
              FROM ITEMSOLI INNER JOIN FILIAL ON ITEMSOLI.CDFILSOLI = FILIAL.CDFILIAL
                            INNER JOIN LISTA  ON LISTA.CDLISTA = FILIAL.CDREGIAO
                            INNER JOIN PRODUTO ON ITEMSOLI.CDPRODUTO = PRODUTO.CDPRODUTO
             WHERE ITEMSOLI.CDFILSOLI = @C_FILGRUPFILI_CDFILIAL
               AND ITEMSOLI.DTPROGENTR BETWEEN @P_DTINI AND @P_DTFIN
               AND ITEMSOLI.IDITMCONS  = 'N'
               AND ITEMSOLI.CDFILIOPELOG IS NULL
               AND ISNULL(ITEMSOLI.IDSOLIAPROV,'S') = 'S'
               AND ((ITEMSOLI.IDITMSOLEXTRA = @P_EXTRA) OR (@P_EXTRA = 'X'))
               AND PRODUTO.CDARVPROD BETWEEN @V_PRODINI AND @V_PRODFIN
               AND ISNULL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) = @P_CDCENTCMP
               AND FILIAL.IDCNTRRESC <> 'S'
               AND LISTA.NRLISTA = @V_LISTA_REGIAO
               AND EXISTS (SELECT PRODCOMP.CDOPERADOR
                             FROM PRODCOMP INNER JOIN PRODUTO PC ON PRODCOMP.CDPRODUTO = PC.CDPRODUTO
                            WHERE PRODCOMP.CDOPERADOR BETWEEN @V_CDOPERINI AND @V_CDOPERFIN
                              AND PRODUTO.CDARVPROD LIKE PC.CDARVPROD + '%')
             GROUP BY FILIAL.CDREGIAO, ITEMSOLI.CDFILSOLI, CASE WHEN @V_IDFUNCAOFILICMPOL = 'N'
                                                                THEN PRODUTO.CDPRODESTO
                                                                ELSE PRODUTO.CDPRODUTO
                                                           END,
                   ITEMSOLI.DTPROGENTR, CASE WHEN @C_FILGRUPFILI_IDFUNCAOFILI = 'O'
                                             THEN ISNULL(ITEMSOLI.CDMARCA, @V_CDMARCA_PADRAO)
                                             ELSE NULL
                                        END;
         OPEN C_ITEMSOLI;
         FETCH NEXT FROM C_ITEMSOLI INTO @C_ITEMSOLI_CDPRODESTO, @C_ITEMSOLI_CDFILSOLI, @C_ITEMSOLI_DTPROGENTR,
                                         @C_ITEMSOLI_CDREGIAO, @C_ITEMSOLI_CDMARCA, @C_ITEMSOLI_QTDEACOMP;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            SELECT @V_IDPRODATIV = ISNULL(MAX(PRODFILI.IDPRODATIV), 'A')
              FROM PRODFILI
             WHERE PRODFILI.CDFILIAL  = @C_ITEMSOLI_CDFILSOLI
               AND PRODFILI.CDPRODUTO = @C_ITEMSOLI_CDPRODESTO;

            IF @V_IDPRODATIV = 'A' BEGIN
               SET @V_CTPRODCMP = 0;

               IF @V_ITEM = 'S' BEGIN
                   SELECT @V_CTPRODCMP = COUNT(1)
                     FROM PRODCMPFILI_TMP PRODCMPFILI INNER JOIN PRODUTO ON PRODCMPFILI.CDPRODUTO = PRODUTO.CDPRODUTO
                                                      CROSS JOIN PRODUTO PRODESTO
                    WHERE PRODESTO.CDPRODUTO = @C_ITEMSOLI_CDPRODESTO
                      AND PRODCMPFILI.CDFILIAL = @C_ITEMSOLI_CDFILSOLI
                      AND PRODCMPFILI.NRSEQAPUR = @P_NRSEQAPUR
                      AND PRODESTO.CDARVPROD LIKE PRODUTO.CDARVPROD+'%'
                      AND PRODUTO.CDARVPROD > (SELECT ISNULL(MAX(PR.CDARVPROD),'0')
                                                 FROM PRODNCMP INNER JOIN PRODUTO PR ON PRODNCMP.CDPRODUTO = PR.CDPRODUTO
                                                WHERE PRODESTO.CDARVPROD LIKE PR.CDARVPROD+'%'
                                                  AND PRODNCMP.CDFILIAL = @C_ITEMSOLI_CDFILSOLI);
               END;

               IF @V_ITEM = 'T' BEGIN
                  SELECT @V_CTPRODCMP = COUNT(1)
                    FROM PRODCMPFILI_TMP PRODCMPFILI INNER JOIN PRODUTO ON PRODCMPFILI.CDPRODUTO = PRODUTO.CDPRODUTO
                                                     CROSS JOIN PRODUTO PRODESTO
                   WHERE PRODESTO.CDPRODUTO = @C_ITEMSOLI_CDPRODESTO
                     AND PRODCMPFILI.CDFILIAL = @C_ITEMSOLI_CDFILSOLI
                     AND PRODCMPFILI.NRSEQAPUR = @P_NRSEQAPUR
                     AND PRODCMPFILI.CDFILIAL <> @P_FILIPROC
                     AND PRODESTO.CDARVPROD LIKE PRODUTO.CDARVPROD+'%'
                     AND PRODUTO.CDARVPROD > (SELECT ISNULL(MAX(PR.CDARVPROD),'0')
                                                FROM PRODNCMP INNER JOIN PRODUTO PR ON PRODNCMP.CDPRODUTO = PR.CDPRODUTO
                                               WHERE PRODESTO.CDARVPROD LIKE PR.CDARVPROD+'%'
                                                 AND PRODNCMP.CDFILIAL = @C_ITEMSOLI_CDFILSOLI);
                  IF @V_CTPRODCMP = 0 BEGIN
                     SET @V_CTPRODCMP = 1;
                  END
                  ELSE BEGIN
                     SET @V_CTPRODCMP = 0;
                  END;
               END;

               SET @V_CDARVPROD = '';

               IF @V_CTPRODCMP > 0 BEGIN
                  SELECT @V_CDARVPROD = MAX(CDARVPROD)
                    FROM PRODUTO
                   WHERE CDPRODUTO = @C_ITEMSOLI_CDPRODESTO;

                  SELECT @V_CTPRODCMP = COUNT(*)
                    FROM PRODNCMP, PRODUTO
                   WHERE PRODNCMP.CDPRODUTO = PRODUTO.CDPRODUTO
                     AND PRODNCMP.CDFILIAL = @C_ITEMSOLI_CDFILSOLI
                     AND @V_CDARVPROD LIKE PRODUTO.CDARVPROD+'%'
                     AND PRODUTO.CDARVPROD > (SELECT ISNULL(MAX(PR.CDARVPROD), '0')
                                                FROM PRODCMPFILI, PRODUTO PR
                                               WHERE PRODCMPFILI.CDPRODUTO = PR.CDPRODUTO
                                                 AND @V_CDARVPROD LIKE PR.CDARVPROD+'%'
                                                 AND PRODCMPFILI.CDFILIAL = @C_ITEMSOLI_CDFILSOLI);
                  IF @V_CTPRODCMP > 0 BEGIN
                     SET @V_CTPRODCMP = 0;
                  END
                  ELSE BEGIN
                     SET @V_CTPRODCMP = 1;
                  END;
               END;

               IF @V_CTPRODCMP > 0 BEGIN
                  SET @V_QTACOMPRAR = @C_ITEMSOLI_QTDEACOMP;
                  IF (@V_IDFUNCAOFILICMPOL = 'N') AND (@C_FILGRUPFILI_IDFUNCAOFILI <> 'O') BEGIN                  
                     SET @V_QTDECOMP = 0;
                     SELECT @V_QTDECOMP = SUM(ITEMAUTF.QTPROGENTAF * PRODUTO.VRFATOCONV) 
                       FROM AUTOFORNE INNER JOIN ITEMAUTF ON AUTOFORNE.CDFILDEST = ITEMAUTF.CDFILDEST
                                                         AND AUTOFORNE.CDFILLANC = ITEMAUTF.CDFILLANC
                                                         AND AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN
                                      INNER JOIN PRODUTO ON ITEMAUTF.CDPRODUTO = PRODUTO.CDPRODUTO
                      WHERE PRODUTO.CDPRODESTO = @C_ITEMSOLI_CDPRODESTO
                        AND ((AUTOFORNE.IDAUTOFORNEX = @P_EXTRA) OR ((@P_EXTRA = 'X') AND (AUTOFORNE.IDAUTOFORNEX = 'N')))
                        AND ISNULL(AUTOFORNE.IDBAIXAAF,'0') <> '5'
                        AND ITEMAUTF.CDFILDEST = @C_ITEMSOLI_CDFILSOLI
                        AND ITEMAUTF.DTENTRITMSOL = @C_ITEMSOLI_DTPROGENTR
                      GROUP BY ITEMAUTF.CDFILDEST, ITEMAUTF.DTENTRITMSOL, PRODUTO.CDPRODESTO;
                  END
                  ELSE BEGIN
                     SET @V_QTDECOMP = 0;
                     SELECT @V_QTDECOMP = SUM(ITEMAUTF.QTPROGENTAF*CASE WHEN PRODUTO.CDPRODUTO = RELACPRODOLEST.CDPRARVORIG
                                                                        THEN 1
                                                                        ELSE PRODUTO.VRFATOCONV
                                                                   END) 
                       FROM AUTOFORNE INNER JOIN ITEMAUTF ON AUTOFORNE.CDFILDEST  = ITEMAUTF.CDFILDEST
                                                         AND AUTOFORNE.CDFILLANC  = ITEMAUTF.CDFILLANC
                                                         AND AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN
                                      INNER JOIN RELACPRODOL ON ITEMAUTF.CDPRODUTO = RELACPRODOL.CDPRODARVOL
                                                            AND ITEMAUTF.CDMARCA = RELACPRODOL.CDMARCA
                                      INNER JOIN PRODUTO PRODUTOOL ON RELACPRODOL.CDPRODARVOL = PRODUTOOL.CDPRODUTO
                                      INNER JOIN RELACPRODOL RELACPRODOLEST ON RELACPRODOLEST.CDPRODARVOL = PRODUTOOL.CDPRODESTO
                                      INNER JOIN PRODUTO PRODUTORIG ON RELACPRODOLEST.CDPRARVORIG = PRODUTORIG.CDPRODUTO
                                      INNER JOIN PRODUTO ON RELACPRODOL.CDPRARVORIG = PRODUTO.CDPRODUTO
                      WHERE ((AUTOFORNE.IDAUTOFORNEX = @P_EXTRA) OR ((@P_EXTRA = 'X') AND (AUTOFORNE.IDAUTOFORNEX = 'N')))
                        AND ISNULL(AUTOFORNE.IDBAIXAAF,'0') <> '5'
                        AND ITEMAUTF.CDFILDEST = @C_ITEMSOLI_CDFILSOLI
                        AND ITEMAUTF.DTENTRITMSOL = @C_ITEMSOLI_DTPROGENTR
                        AND RELACPRODOLEST.CDPRARVORIG = @C_ITEMSOLI_CDPRODESTO
                        AND ((@V_IDUTLMARPREFOL = 'N') OR (ITEMAUTF.CDMARCA = @C_ITEMSOLI_CDMARCA))
                      GROUP BY ITEMAUTF.CDFILDEST, ITEMAUTF.DTENTRITMSOL, ITEMAUTF.CDPRODUTO;
                  END;
                  SET @V_QTACOMPRAR = @V_QTACOMPRAR - ISNULL(@V_QTDECOMP,0);

                  IF ROUND(@V_QTACOMPRAR,3,1) > 0 BEGIN
                     DECLARE C_GRAVA CURSOR FOR
                        SELECT ITEMCOLE.CDFILIAL, ITEMCOLE.CDPRODUTO, PRODUTO.VRFATOCONV, ITEMCOLE.NRCOLEPRECO,
                               ITEMCOLE.CDFORNECED, ITEMCOLE.CDREGIAO, ITEMCOLE.CDMARCA, ITEMCOLE.CDTIPCOB,
                               ITEMCOLE.CDFORMPGTO, ITEMCOLE.IDUTDIAPGCOL, ITEMCOLE.IDTPFOPGTCOL, ITEMCOLE.IDTIPFREITM,
                               ITEMCOLE.NRPARCPGTCOL, ITEMCOLE.CDSEGMARCCOL, ITEMCOLE.VRPRECUNIITM, ITEMCOLE.VRPERDESITM,
                               ITEMCOLE.NRDIAPGFXCOL,  ITEMCOLE.VRPRECECOITM, ITEMCOLE.VRPRECOITMPI, ITEMCOLE.IDITMLISPREC,
                               ITEMCOLE.NRSEQPRELIST
                          FROM COLETAPR INNER JOIN ITEMCOLE ON COLETAPR.CDFILIAL = ITEMCOLE.CDFILIAL
                                                           AND COLETAPR.NRCOLEPRECO = ITEMCOLE.NRCOLEPRECO
                                        INNER JOIN PRODUTO ON PRODUTO.CDPRODUTO = ITEMCOLE.CDPRODUTO
                                        INNER JOIN FORNECEDOR ON FORNECEDOR.CDFORNECED = ITEMCOLE.CDFORNECED
                                        LEFT  JOIN PRMARCPEDCOL ON PRMARCPEDCOL.CDFILIAL = ITEMCOLE.CDFILIAL
                                                               AND PRMARCPEDCOL.NRPEDIDOCOL = ITEMCOLE.NRPEDIDOCOL
                                                               AND PRMARCPEDCOL.CDPRODUTO = ITEMCOLE.CDPRODUTO
                                                               AND PRMARCPEDCOL.CDMARCA = ITEMCOLE.CDMARCA
                         WHERE COLETAPR.CDFILIAL = @P_CDCENTCMP
                           AND COLETAPR.CDOPERADOR BETWEEN @V_CDOPERINI AND @V_CDOPERFIN
                           AND COLETAPR.NRCOMPRA IS NULL
                           AND (((ITEMCOLE.IDITMLISPREC = @V_ITEM) AND ISNULL(ITEMCOLE.IDPRECALT,'S') = 'S') OR (@V_ITEM = 'T'))
                           AND ITEMCOLE.VRPRECUNIITM <> 0
                           AND ITEMCOLE.CDREGIAO = @C_ITEMSOLI_CDREGIAO
                           AND @C_ITEMSOLI_DTPROGENTR BETWEEN ITEMCOLE.DTINIVALITM AND ITEMCOLE.DTFINVALITM
                           AND FORNECEDOR.IDSITUCADA = 'A'
                           AND FORNECEDOR.IDTIPOFORN <> 'A'
                           AND ((@V_IDUTQTDISPGERAL = 'N') OR (ISNULL(FORNECEDOR.IDUTQTDISPFORN, 'N') = 'N') OR (ISNULL(PRMARCPEDCOL.QTDISPPRODMARC, 1) > 0))
                           AND ((@V_IDUTISTATCOT = 'N') OR (ISNULL(COLETAPR.IDSITUCOLETA, 'C') = 'C'))
                           AND NOT EXISTS (SELECT REFOREG.CDREGIAO
                                             FROM REFOREG
                                            WHERE REFOREG.CDREGIAO = @C_ITEMSOLI_CDREGIAO
                                              AND REFOREG.CDFORNECED = ITEMCOLE.CDFORNECED)
                           AND NOT EXISTS (SELECT QFOPRODFORN.CDPRODUTO
                                             FROM QFOPRODFORN INNER JOIN PARASUPRI ON QFOPRODFORN.CDPRODUTO = PRODUTO.CDPRODUTO
                                            WHERE PARASUPRI.CDFILIAL = @P_CDCENTCMP
                                              AND QFOPRODFORN.CDFORNECED = ITEMCOLE.CDFORNECED
                                              AND ((QFOPRODFORN.IDFORNAPROV = 'N' AND QFOPRODFORN.IDFORNAUTOR = 'N') OR
                                                  ((QFOPRODFORN.IDFORNAPROV = 'S') AND
                                                  ((PARASUPRI.IDULTIDTVALQ = 'M' AND
                                                  COLETAPR.DTCOLEPREC > (DATEADD(MONTH, DATEDIFF(MONTH, 0, QFOPRODFORN.DTVALPRFORN) + 1, 0) - 1)) OR
                                                  (PARASUPRI.IDULTIDTVALQ = 'D' AND
                                                  COLETAPR.DTCOLEPREC > QFOPRODFORN.DTVALPRFORN)))))
                           AND NOT EXISTS (SELECT QFOMARPROD.CDMARCA
                                             FROM QFOMARPROD CROSS JOIN PARASUPRI
                                            WHERE PARASUPRI.CDFILIAL = @P_CDCENTCMP
                                              AND QFOMARPROD.CDPRODUTO = PRODUTO.CDPRODUTO
                                              AND QFOMARPROD.CDMARCA   = ITEMCOLE.CDMARCA
                                              AND ((QFOMARPROD.IDAPRMARPRO = 'N' AND QFOMARPROD.IDAUTMARPRO = 'N') OR
                                                  ((QFOMARPROD.IDAPRMARPRO = 'S') AND
                                                  ((PARASUPRI.IDULTIDTVALQ = 'M' AND
                                                  COLETAPR.DTCOLEPREC > (DATEADD(MONTH, DATEDIFF(MONTH, 0, QFOMARPROD.DTVALAPROVA) + 1, 0) - 1)) OR
                                                  (PARASUPRI.IDULTIDTVALQ = 'D' AND
                                                  COLETAPR.DTCOLEPREC > QFOMARPROD.DTVALAPROVA)))))
                           AND EXISTS (SELECT QFOMARPROD.CDMARCA
                                         FROM QFOMARPROD
                                        WHERE QFOMARPROD.CDPRODUTO = PRODUTO.CDPRODUTO
                                          AND QFOMARPROD.CDMARCA   = ITEMCOLE.CDMARCA
                                        UNION
                                       SELECT PARASUPRI.CDMARCA
                                         FROM PARASUPRI
                                        WHERE PARASUPRI.CDFILIAL    = @P_CDCENTCMP
                                          AND (PARASUPRI.IDMARSEMQUA = 'N' OR PARASUPRI.IDMARSEMQUA IS NULL))
                           AND NOT EXISTS (SELECT QUALIFICACAO.CDQUALIF
                                             FROM QUALIFICACAO CROSS JOIN PARASUPRI
                                            WHERE PARASUPRI.CDFILIAL  = @P_CDCENTCMP
                                              AND FORNECEDOR.CDQUALIF = QUALIFICACAO.CDQUALIF
                                              AND FORNECEDOR.IDFORNAUTO = 'N'
                                              AND ((QUALIFICACAO.IDPERCOTCMP = '2')                   OR
                                                  ((PARASUPRI.IDULTIDTVALQ  = 'D'                    AND
                                                  COLETAPR.DTCOLEPREC > FORNECEDOR.DTVALQUALIF)       OR
                                                  (PARASUPRI.IDULTIDTVALQ = 'M'                      AND
                                                  COLETAPR.DTCOLEPREC > (DATEADD(MONTH, DATEDIFF(MONTH, 0, FORNECEDOR.DTVALQUALIF) + 1, 0) - 1)))))
                           AND NOT EXISTS (SELECT REFORFIL.CDFILIAL 
                                             FROM REFORFIL
                                            WHERE REFORFIL.CDFILIAL = @C_ITEMSOLI_CDFILSOLI
                                              AND REFORFIL.CDPERIENTR IS NULL
                                              AND REFORFIL.CDFORNECED = ITEMCOLE.CDFORNECED)
                           AND ((@V_IDFUNCAOFILICMPOL = 'N' AND  (@C_FILGRUPFILI_IDFUNCAOFILI <> 'O') AND (PRODUTO.CDPRODESTO = @C_ITEMSOLI_CDPRODESTO)) OR
                               ((@V_IDFUNCAOFILICMPOL = 'S') AND (@C_FILGRUPFILI_IDFUNCAOFILI = 'O')
                               AND EXISTS (SELECT 1 
                                             FROM PRODUTO PRODUTOOL, RELACPRODOL RELACPRODOLEST, RELACPRODOL
                                            WHERE PRODUTOOL.CDPRODESTO       = RELACPRODOL.CDPRODARVOL
                                              AND PRODUTOOL.CDPRODUTO        = RELACPRODOLEST.CDPRODARVOL
                                              AND RELACPRODOL.CDPRARVORIG    = @C_ITEMSOLI_CDPRODESTO
                                              AND RELACPRODOLEST.CDPRARVORIG = PRODUTO.CDPRODUTO)));                         
                     OPEN C_GRAVA;
                     FETCH NEXT FROM C_GRAVA INTO @C_GRAVA_CDFILIAL, @C_GRAVA_CDPRODUTO, @C_GRAVA_VRFATOCONV,
                                                  @C_GRAVA_NRCOLEPRECO, @C_GRAVA_CDFORNECED, @C_GRAVA_CDREGIAO,
                                                  @C_GRAVA_CDMARCA, @C_GRAVA_CDTIPCOB, @C_GRAVA_CDFORMPGTO,
                                                  @C_GRAVA_IDUTDIAPGCOL, @C_GRAVA_IDTPFOPGTCOL, @C_GRAVA_IDTIPFREITM,
                                                  @C_GRAVA_NRPARCPGTCOL, @C_GRAVA_CDSEGMARCCOL, @C_GRAVA_VRPRECUNIITM,
                                                  @C_GRAVA_VRPERDESITM, @C_GRAVA_NRDIAPGFXCOL, @C_GRAVA_VRPRECECOITM,
                                                  @C_GRAVA_VRPRECOITMPI, @C_GRAVA_IDITMLISPREC, @C_GRAVA_NRSEQPRELIST;

                     WHILE (@@FETCH_STATUS = 0) BEGIN
					
                        SET @V_CTIMPOSTO = NULL;
                        SET @V_CONCKEY   = NULL;

                        IF @V_IDSEPAFIMP = 'S' BEGIN
                           SELECT @V_CTIMPOSTO = COUNT(1)
                             FROM IMPCOLET
                            WHERE CDFILIAL = @C_GRAVA_CDFILIAL
                              AND NRCOLEPRECO = @C_GRAVA_NRCOLEPRECO
                              AND CDMARCA = @C_GRAVA_CDMARCA
                              AND CDREGIAO = @C_GRAVA_CDREGIAO
                              AND CDFORNECED = @C_GRAVA_CDFORNECED
                              AND CDPRODUTO = @C_GRAVA_CDPRODUTO;

                           IF @V_CTIMPOSTO = 0 BEGIN
                              SET @V_CONCKEY = '?';
                           END
                           ELSE BEGIN
                              IF @V_CTIMPOSTO = 1 BEGIN
                                 SELECT @V_CONCKEY = CDIMPOSTO
                                   FROM IMPCOLET
                                  WHERE CDFILIAL = @C_GRAVA_CDFILIAL
                                    AND NRCOLEPRECO = @C_GRAVA_NRCOLEPRECO
                                    AND CDMARCA = @C_GRAVA_CDMARCA
                                    AND CDREGIAO = @C_GRAVA_CDREGIAO
                                    AND CDFORNECED = @C_GRAVA_CDFORNECED
                                    AND CDPRODUTO = @C_GRAVA_CDPRODUTO
                                  GROUP BY CDIMPOSTO;
                              END
                              ELSE BEGIN
                                 IF @V_CTIMPOSTO > 1 BEGIN
                                    SET @V_CONCKEY = '*';
                                 END;
                              END;
                           END;
                        END;
          
                        SET @V_EMITENTE  = TEKNISA.EMITENTE(@C_ITEMSOLI_CDFILSOLI, @C_GRAVA_CDPRODUTO, @C_GRAVA_CDFORNECED);
                        SET @V_CDEMPRESA = SUBSTRING(@V_EMITENTE, 3, 2);
                        SET @V_CONCKEY   = @V_CONCKEY+@C_GRAVA_CDFILIAL+ @C_GRAVA_CDFORNECED +SUBSTRING(@V_EMITENTE, 3, 2)+
                                        @C_GRAVA_IDTPFOPGTCOL +
                                        @C_GRAVA_CDTIPCOB     + @C_GRAVA_IDTIPFREITM  +
                                        @C_GRAVA_CDFORMPGTO   + CONVERT(CHAR, @C_GRAVA_NRPARCPGTCOL) +
                                        CONVERT(CHAR, @C_GRAVA_NRDIAPGFXCOL) + @C_GRAVA_IDUTDIAPGCOL +SUBSTRING(@V_EMITENTE, 1, 1);
                        
                        SET @V_IDTIPEMIT = SUBSTRING(@V_EMITENTE, 1, 1);
                        /*SET @V_DSPZOPGTCONC = TEKNISA.CONCAT_PZO_PAGTO(@C_GRAVA_CDFILIAL,   @C_GRAVA_NRCOLEPRECO,
                                                                       @C_GRAVA_CDFORNECED, @C_GRAVA_CDPRODUTO,
                                                                       @C_GRAVA_CDMARCA,    @C_GRAVA_CDREGIAO); */
                                                                       
                        SET @V_NRPGTCOLCAR = '';
                        SET @V_DSPZOPGTCONC = '';

                        DECLARE C_PZO_PGTO CURSOR FOR
                           SELECT CONVERT(VARCHAR, NRDIASPGTCOL) AS NRPZOPGT, CONVERT(VARCHAR, VRPERCPGTCOL) AS VRPERPGT
                             FROM PZOPGTITMCOL
                            WHERE CDFILIAL    = @C_GRAVA_CDFILIAL
                              AND NRCOLEPRECO = @C_GRAVA_NRCOLEPRECO
                              AND CDFORNECED  = @C_GRAVA_CDFORNECED
                              AND CDPRODUTO   = @C_GRAVA_CDPRODUTO
                              AND CDMARCA     = @C_GRAVA_CDMARCA
                              AND CDREGIAO    = @C_GRAVA_CDREGIAO
                            ORDER BY NRDIASPGTCOL, VRPERCPGTCOL
       
                        OPEN C_PZO_PGTO;
                        FETCH NEXT FROM C_PZO_PGTO INTO @V_PZO_PGTO_NRPZOPGT, @V_PZO_PGTO_VRPERPGT;
                        
                        WHILE (@@FETCH_STATUS = 0) BEGIN
                           SET @V_NRPGTCOLCAR = @V_NRPGTCOLCAR + ISNULL(@V_PZO_PGTO_NRPZOPGT,'') + '*' + ISNULL(@V_PZO_PGTO_VRPERPGT,'') + '_';
                     
                           FETCH NEXT FROM C_PZO_PGTO INTO @V_PZO_PGTO_NRPZOPGT, @V_PZO_PGTO_VRPERPGT;
                        END;
                        CLOSE C_PZO_PGTO;
                        DEALLOCATE C_PZO_PGTO;
                                                                       
                        SET @V_DSPZOPGTCONC  = @V_NRPGTCOLCAR;

                        SELECT @V_VRARREDCMP = CASE MAX(VRARREDCMP) WHEN NULL THEN 0 ELSE MAX(VRARREDCMP) END
                          FROM PRODUTO
                         WHERE CDPRODUTO = @C_GRAVA_CDPRODUTO;

                        SET @V_QTACOMPRAR_AUX = @V_QTACOMPRAR / CASE WHEN ISNULL(@C_GRAVA_VRFATOCONV, 0) = 0 THEN 1 ELSE @C_GRAVA_VRFATOCONV END;
                        IF @V_VRARREDCMP > 0 BEGIN
                           IF (((CAST(@V_QTACOMPRAR_AUX AS DOUBLE PRECISION) / @V_VRARREDCMP)  - (ROUND(@V_QTACOMPRAR_AUX / @V_VRARREDCMP, 0, 1))) <> 0) BEGIN
                              SET @V_QTACOMPRAR_AUX = CEILING(CAST(@V_QTACOMPRAR_AUX AS DOUBLE PRECISION) / @V_VRARREDCMP) * @V_VRARREDCMP;
                           END;
                        END;

                        /* Grava quantidade a comprar com valor arredondado para menos */
                        IF @V_IDARREDCMPAMENOS = 'S' BEGIN
                           IF @V_QTACOMPRAR_AUX <> FLOOR(@V_QTACOMPRAR_AUX) BEGIN
                              IF FLOOR(@V_QTACOMPRAR_AUX) = 0 BEGIN
                                 SET @V_QTACOMPRAR_AUX = 1;
                              END;
                           END;
                        END;

                        SET @V_IDAFOPERLOG  = 'X';
                        SET @V_CDFILIOPELOG = NULL;
                        SET @V_CDFORNOPELOG = NULL;

                        IF @V_IDUTILCONSSOLIOL = 'N' BEGIN
                           SELECT @V_IDAFOPERLOG = ISNULL(MAX('2'), 'X')
                             FROM PARAMPRODSUP
                            WHERE CDFILIAL = @C_ITEMSOLI_CDFILSOLI
                              AND CDPRODUTO = @C_GRAVA_CDPRODUTO
                              AND CDFILIOPELOG IS NOT NULL;

                           SELECT @V_CDFILIOPELOG = MAX(P.CDFILIOPELOG), @V_CDFORNOPELOG = MAX(F.CDFORNOPELOG)
                             FROM PARAMPRODSUP P INNER JOIN FILIAL F ON P.CDFILIOPELOG = F.CDFILIAL
                            WHERE P.CDFILIAL = @C_ITEMSOLI_CDFILSOLI
                              AND P.CDPRODUTO = @C_GRAVA_CDPRODUTO;

                           IF @V_CDFORNOPELOG <> @C_GRAVA_CDFORNECED BEGIN
                              SET @V_IDAFOPERLOG  = 'X';
                              SET @V_CDFILIOPELOG = NULL;
                           END;
                        END;

                        SET @V_IDPRODWEB = 'N';
                        SELECT @V_IDPRODWEB = ISNULL(MAX(PARAMPRODSUP.IDPRODWEB), 'N')
                          FROM PARAMPRODSUP
                         WHERE CDFILIAL = @C_ITEMSOLI_CDFILSOLI
                           AND CDPRODUTO = @C_GRAVA_CDPRODUTO
                           AND CDFORNECED = @C_GRAVA_CDFORNECED;

                        IF @V_CDFILIOPELOG IS NULL BEGIN
                           SET @V_CDFILIOPELOG = 'OL_NULL';
                        END;

                        INSERT INTO ITMAPURPREC (CDCENTITMAP, NRSEQITMAP, CDFILIAP, DTENTRAPUT, CDPRODITMAP, NRCOLEITMAP,
                                                 CDFORNITMAP, CDREGITMAP, CDMARCITMAP, QTSOLACOMP, QTACOMP, CDTIPCOBAP,
                                                 CDEMPRESAAP, CDFORMPGTOAP, IDULTDIAPGTAF, CONCKEYAP, IDTPFORPGTAP, IDTIPOEMITAP,
                                                 IDTIPOFRETAP, NRPARCPGTOAP, CDSEGMARCCOL, VRPRECUNIAP, VRPERDESIAP, NRDIAPGFIAP,
                                                 DSPZOPGTCOAP, VRPRECECOAP, VRPRECONPIAP, IDITMLISPRAP, NRLISTAITMAP)
                             SELECT  @P_CDCENTCMP, @P_NRSEQAPUR, @C_ITEMSOLI_CDFILSOLI, @C_ITEMSOLI_DTPROGENTR, @C_GRAVA_CDPRODUTO, @C_GRAVA_NRCOLEPRECO,
                                     @C_GRAVA_CDFORNECED, @C_GRAVA_CDREGIAO, @C_GRAVA_CDMARCA, @V_QTACOMPRAR_AUX, @V_QTACOMPRAR_AUX, @C_GRAVA_CDTIPCOB,
                                     @V_CDEMPRESA, @C_GRAVA_CDFORMPGTO, @C_GRAVA_IDUTDIAPGCOL, @V_CONCKEY+@V_CDFILIOPELOG+@V_IDPRODWEB+@V_IDAFOPERLOG, @C_GRAVA_IDTPFOPGTCOL, @V_IDTIPEMIT,
                                     @C_GRAVA_IDTIPFREITM, @C_GRAVA_NRPARCPGTCOL, @C_GRAVA_CDSEGMARCCOL, @C_GRAVA_VRPRECUNIITM, @C_GRAVA_VRPERDESITM, @C_GRAVA_NRDIAPGFXCOL,
                                     @V_DSPZOPGTCONC, @C_GRAVA_VRPRECECOITM, @C_GRAVA_VRPRECOITMPI, @C_GRAVA_IDITMLISPREC, @C_GRAVA_NRSEQPRELIST
                               FROM  PARAMGERAL
                              WHERE NOT EXISTS(SELECT 1
                                                 FROM ITMAPURPREC I
                                                WHERE @P_CDCENTCMP  = I.CDCENTITMAP
                                                  AND @P_NRSEQAPUR  = I.NRSEQITMAP
                                                  AND @C_ITEMSOLI_CDFILSOLI     = I.CDFILIAP
                                                  AND  @C_ITEMSOLI_DTPROGENTR   = I.DTENTRAPUT
                                                  AND @C_GRAVA_CDPRODUTO        = I.CDPRODITMAP
                                                  AND @C_GRAVA_NRCOLEPRECO      = I.NRCOLEITMAP
                                                  AND @C_GRAVA_CDFORNECED  = I.CDFORNITMAP
                                                  AND @C_GRAVA_CDREGIAO   = I.CDREGITMAP
                                                  AND @C_GRAVA_CDMARCA  = I.CDMARCITMAP);

                        IF @@ROWCOUNT > 0 BEGIN
                           SET @P_ROWSAFFECT = 'S';
                        END;

                        FETCH NEXT FROM C_GRAVA INTO @C_GRAVA_CDFILIAL, @C_GRAVA_CDPRODUTO, @C_GRAVA_VRFATOCONV,
                                                     @C_GRAVA_NRCOLEPRECO, @C_GRAVA_CDFORNECED, @C_GRAVA_CDREGIAO,
                                                     @C_GRAVA_CDMARCA, @C_GRAVA_CDTIPCOB, @C_GRAVA_CDFORMPGTO,
                                                     @C_GRAVA_IDUTDIAPGCOL, @C_GRAVA_IDTPFOPGTCOL, @C_GRAVA_IDTIPFREITM,
                                                     @C_GRAVA_NRPARCPGTCOL, @C_GRAVA_CDSEGMARCCOL, @C_GRAVA_VRPRECUNIITM,
                                                     @C_GRAVA_VRPERDESITM, @C_GRAVA_NRDIAPGFXCOL, @C_GRAVA_VRPRECECOITM,
                                                     @C_GRAVA_VRPRECOITMPI, @C_GRAVA_IDITMLISPREC, @C_GRAVA_NRSEQPRELIST;
                     END;
                     CLOSE C_GRAVA;
                     DEALLOCATE C_GRAVA;
                  END;

                  SET @V_QTACOMPRAR = 0;
               END;
            END;
            FETCH NEXT FROM C_ITEMSOLI INTO @C_ITEMSOLI_CDPRODESTO, @C_ITEMSOLI_CDFILSOLI, @C_ITEMSOLI_DTPROGENTR,
                                            @C_ITEMSOLI_CDREGIAO, @C_ITEMSOLI_CDMARCA, @C_ITEMSOLI_QTDEACOMP;
         END;
         CLOSE C_ITEMSOLI;
         DEALLOCATE C_ITEMSOLI;
      END
      ELSE BEGIN
         DECLARE C_ITEMSOLI CURSOR FOR
            SELECT ITEMSOLI.CDPRODUTO, ITEMSOLI.CDFILSOLI, ITEMSOLI.DTPROGENTR, FILIAL.CDREGIAO,
                   CASE WHEN @V_IDUTLMARPREFOL = 'S'
                        THEN ISNULL(ITEMSOLI.CDMARCA, @V_CDMARCA_PADRAO)
                        ELSE NULL
                   END CDMARCA, SUM(ITEMSOLI.QTSOLIPROD) AS QTDEACOMP 
              FROM ITEMSOLI INNER JOIN FILIAL ON ITEMSOLI.CDFILSOLI = FILIAL.CDFILIAL
                            INNER JOIN PRODUTO ON ITEMSOLI.CDPRODUTO = PRODUTO.CDPRODUTO
                            INNER JOIN LISTA ON LISTA.CDLISTA = FILIAL.CDREGIAO
             WHERE ITEMSOLI.CDFILSOLI = @C_FILGRUPFILI_CDFILIAL
               AND ITEMSOLI.DTPROGENTR BETWEEN @P_DTINI AND @P_DTFIN
               AND ITEMSOLI.CDFILIOPELOG IS NULL
               AND ITEMSOLI.IDITMCONS  = 'N'
               AND PRODUTO.CDARVPROD BETWEEN @V_PRODINI AND @V_PRODFIN
               AND ISNULL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) = @P_CDCENTCMP
               AND FILIAL.IDCNTRRESC <> 'S'
               AND LISTA.NRLISTA = @V_LISTA_REGIAO
               AND ISNULL(ITEMSOLI.IDSOLIAPROV, 'S') = 'S'
               AND ((ITEMSOLI.IDITMSOLEXTRA = @P_EXTRA) OR (@P_EXTRA = 'X'))
               AND EXISTS (SELECT PRODCOMP.CDOPERADOR
                             FROM PRODCOMP INNER JOIN PRODUTO PC ON PRODCOMP.CDPRODUTO = PC.CDPRODUTO
                            WHERE PRODCOMP.CDOPERADOR BETWEEN @V_CDOPERINI AND @V_CDOPERFIN
                              AND PRODUTO.CDARVPROD LIKE PC.CDARVPROD + '%')
             GROUP BY FILIAL.CDREGIAO, ITEMSOLI.CDFILSOLI, ITEMSOLI.CDPRODUTO,
                      CASE WHEN @V_IDUTLMARPREFOL = 'S'
                        THEN ISNULL(ITEMSOLI.CDMARCA, @V_CDMARCA_PADRAO)
                        ELSE NULL
                      END, ITEMSOLI.DTPROGENTR;
         OPEN C_ITEMSOLI;
         FETCH NEXT FROM C_ITEMSOLI INTO @C_ITEMSOLI_CDPRODESTO, @C_ITEMSOLI_CDFILSOLI, @C_ITEMSOLI_DTPROGENTR,
                                         @C_ITEMSOLI_CDREGIAO, @C_ITEMSOLI_CDMARCA, @C_ITEMSOLI_QTDEACOMP;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            SELECT @V_IDPRODATIV = ISNULL(MAX(PRODFILI.IDPRODATIV), 'A')
              FROM PRODFILI
             WHERE PRODFILI.CDFILIAL  = @C_ITEMSOLI_CDFILSOLI
               AND PRODFILI.CDPRODUTO = @C_ITEMSOLI_CDPRODESTO;

            IF @V_IDPRODATIV = 'A' BEGIN
               SET @V_CTPRODCMP = 0;

               IF @V_ITEM = 'S' BEGIN
                  SELECT @V_CTPRODCMP = COUNT(1)
                    FROM PRODCMPFILI_TMP PRODCMPFILI INNER JOIN PRODUTO ON PRODCMPFILI.CDPRODUTO = PRODUTO.CDPRODUTO
                                                     CROSS JOIN PRODUTO P
                   WHERE P.CDPRODUTO = @C_ITEMSOLI_CDPRODESTO
                     AND PRODCMPFILI.CDFILIAL = @C_ITEMSOLI_CDFILSOLI
                     AND PRODCMPFILI.NRSEQAPUR = @P_NRSEQAPUR
                     AND P.CDARVPROD LIKE PRODUTO.CDARVPROD+'%'
                     AND PRODUTO.CDARVPROD > (SELECT ISNULL(MAX(PR.CDARVPROD), '0')
                                                FROM PRODNCMP INNER JOIN PRODUTO PR ON PRODNCMP.CDPRODUTO = PR.CDPRODUTO
                                               WHERE P.CDARVPROD LIKE PR.CDARVPROD+'%'
                                                 AND PRODNCMP.CDFILIAL = @C_ITEMSOLI_CDFILSOLI);
               END;

               IF @V_ITEM = 'T' BEGIN
                  SELECT @V_CTPRODCMP = COUNT(1) 
                    FROM PRODCMPFILI_TMP PRODCMPFILI INNER JOIN PRODUTO ON PRODCMPFILI.CDPRODUTO = PRODUTO.CDPRODUTO
                                                     CROSS JOIN PRODUTO P
                   WHERE P.CDPRODUTO = @C_ITEMSOLI_CDPRODESTO
                     AND PRODCMPFILI.CDFILIAL = @C_ITEMSOLI_CDFILSOLI
                     AND PRODCMPFILI.CDFILIAL <> @P_FILIPROC
                     AND PRODCMPFILI.NRSEQAPUR = @P_NRSEQAPUR
                     AND P.CDARVPROD LIKE PRODUTO.CDARVPROD+'%'
                     AND PRODUTO.CDARVPROD > (SELECT ISNULL(MAX(PR.CDARVPROD),'0')
                                                FROM PRODNCMP INNER JOIN PRODUTO PR ON PRODNCMP.CDPRODUTO = PR.CDPRODUTO
                                               WHERE P.CDARVPROD LIKE PR.CDARVPROD+'%'
                                                 AND PRODNCMP.CDFILIAL = @C_ITEMSOLI_CDFILSOLI);
                  IF @V_CTPRODCMP = 0 BEGIN
                     SET @V_CTPRODCMP = 1;
                  END
                  ELSE BEGIN
                     SET @V_CTPRODCMP = 0;                  
                  END;
               END;

               SET @V_CDARVPROD = '';

               IF @V_CTPRODCMP > 0 BEGIN
                  SELECT @V_CDARVPROD = MAX(CDARVPROD)
                    FROM PRODUTO
                   WHERE CDPRODUTO = @C_ITEMSOLI_CDPRODESTO;

                  SELECT @V_CTPRODCMP = COUNT(*)
                    FROM PRODNCMP, PRODUTO
                   WHERE PRODNCMP.CDPRODUTO = PRODUTO.CDPRODUTO
                     AND PRODNCMP.CDFILIAL = @C_ITEMSOLI_CDFILSOLI
                     AND @V_CDARVPROD LIKE PRODUTO.CDARVPROD+'%'
                     AND PRODUTO.CDARVPROD > (SELECT ISNULL(MAX(PR.CDARVPROD), '0')
                                                FROM PRODCMPFILI, PRODUTO PR
                                               WHERE PRODCMPFILI.CDPRODUTO = PR.CDPRODUTO
                                                 AND @V_CDARVPROD LIKE PR.CDARVPROD+'%'
                                                 AND PRODCMPFILI.CDFILIAL = @C_ITEMSOLI_CDFILSOLI);
                  IF @V_CTPRODCMP > 0 BEGIN
                     SET @V_CTPRODCMP = 0;
                  END
                  ELSE BEGIN
                     SET @V_CTPRODCMP = 1;
                  END;
               END;

               IF @V_CTPRODCMP > 0 BEGIN
                  SET @V_QTACOMPRAR = @C_ITEMSOLI_QTDEACOMP;

                  IF (@C_FILGRUPFILI_IDFUNCAOFILI = 'O') AND (@V_IDUTILCONSSOLIOL = 'S') BEGIN
                     SELECT @V_QTDECOMP = SUM(ITEMAUTF.QTPROGENTAF)  
                       FROM AUTOFORNE INNER JOIN ITEMAUTF ON AUTOFORNE.CDFILDEST = ITEMAUTF.CDFILDEST
                                                         AND AUTOFORNE.CDFILLANC = ITEMAUTF.CDFILLANC
                                                         AND AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN
                                      INNER JOIN RELACPRODOL ON ITEMAUTF.CDPRODUTO = RELACPRODOL.CDPRODARVOL
                                                            AND ITEMAUTF.CDMARCA = RELACPRODOL.CDMARCA
                      WHERE ISNULL(AUTOFORNE.IDBAIXAAF,'0') <> '5'
                        AND ((AUTOFORNE.IDAUTOFORNEX = @P_EXTRA) OR ((@P_EXTRA = 'X') AND (AUTOFORNE.IDAUTOFORNEX = 'N')))
                        AND ITEMAUTF.CDFILDEST =  @C_ITEMSOLI_CDFILSOLI
                        AND RELACPRODOL.CDPRARVORIG = @C_ITEMSOLI_CDPRODESTO
                        AND ((@V_IDUTLMARPREFOL = 'N') OR (ITEMAUTF.CDMARCA = @C_ITEMSOLI_CDMARCA))
                        AND ITEMAUTF.DTENTRITMSOL = @C_ITEMSOLI_DTPROGENTR
                      GROUP BY ITEMAUTF.CDFILDEST, ITEMAUTF.DTENTRITMSOL, RELACPRODOL.CDPRARVORIG;
                  END
                  ELSE BEGIN
                     SELECT @V_QTDECOMP = SUM(ITEMAUTF.QTPROGENTAF) 
                       FROM AUTOFORNE INNER JOIN ITEMAUTF ON AUTOFORNE.CDFILDEST = ITEMAUTF.CDFILDEST
                                                         AND AUTOFORNE.CDFILLANC = ITEMAUTF.CDFILLANC
                                                         AND AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN
                      WHERE ((AUTOFORNE.IDAUTOFORNEX = @P_EXTRA) OR ((@P_EXTRA = 'X') AND (AUTOFORNE.IDAUTOFORNEX = 'N')))
                        AND ISNULL(AUTOFORNE.IDBAIXAAF, '0') <> '5'
                        AND ITEMAUTF.CDFILDEST = @C_ITEMSOLI_CDFILSOLI
                        AND ITEMAUTF.CDPRODUTO = @C_ITEMSOLI_CDPRODESTO
                        AND ITEMAUTF.DTENTRITMSOL = @C_ITEMSOLI_DTPROGENTR
                      GROUP BY ITEMAUTF.CDFILDEST, ITEMAUTF.DTENTRITMSOL, ITEMAUTF.CDPRODUTO;
                  END;
                  SET @V_QTACOMPRAR = @V_QTACOMPRAR - ISNULL(@V_QTDECOMP,0);

                  IF ROUND(@V_QTACOMPRAR,3,1) > 0 BEGIN
                     DECLARE C_GRAVA CURSOR FOR
                        SELECT ITEMCOLE.CDFILIAL, ITEMCOLE.CDPRODUTO, PRODUTO.VRFATOCONV, ITEMCOLE.NRCOLEPRECO,
                               ITEMCOLE.CDFORNECED, ITEMCOLE.CDREGIAO, ITEMCOLE.CDMARCA, ITEMCOLE.CDTIPCOB,
                               ITEMCOLE.CDFORMPGTO, ITEMCOLE.IDUTDIAPGCOL, ITEMCOLE.IDTPFOPGTCOL, ITEMCOLE.IDTIPFREITM,
                               ITEMCOLE.NRPARCPGTCOL, ITEMCOLE.CDSEGMARCCOL, ITEMCOLE.VRPRECUNIITM, ITEMCOLE.VRPERDESITM,
                               ITEMCOLE.NRDIAPGFXCOL, ITEMCOLE.VRPRECECOITM, ITEMCOLE.VRPRECOITMPI, ITEMCOLE.IDITMLISPREC,
                               ITEMCOLE.NRSEQPRELIST
                          FROM COLETAPR INNER JOIN ITEMCOLE ON COLETAPR.CDFILIAL = ITEMCOLE.CDFILIAL
                                                           AND COLETAPR.NRCOLEPRECO = ITEMCOLE.NRCOLEPRECO
                                        INNER JOIN PRODUTO ON ITEMCOLE.CDPRODUTO = PRODUTO.CDPRODUTO
                                        INNER JOIN FORNECEDOR ON FORNECEDOR.CDFORNECED = ITEMCOLE.CDFORNECED
                                        LEFT  JOIN PRMARCPEDCOL ON PRMARCPEDCOL.CDFILIAL = ITEMCOLE.CDFILIAL
                                                               AND PRMARCPEDCOL.NRPEDIDOCOL = ITEMCOLE.NRPEDIDOCOL
                                                               AND PRMARCPEDCOL.CDPRODUTO = ITEMCOLE.CDPRODUTO
                                                               AND PRMARCPEDCOL.CDMARCA = ITEMCOLE.CDMARCA
                         WHERE COLETAPR.CDFILIAL = @P_CDCENTCMP
                           AND COLETAPR.CDOPERADOR BETWEEN @V_CDOPERINI AND @V_CDOPERFIN
                           AND @C_ITEMSOLI_CDPRODESTO = ITEMCOLE.CDPRODUTO
                           AND ((@V_IDUTQTDISPGERAL = 'N') OR (ISNULL(FORNECEDOR.IDUTQTDISPFORN, 'N') = 'N') OR (ISNULL(PRMARCPEDCOL.QTDISPPRODMARC, 1) > 0))
                           AND ((ITEMCOLE.IDITMLISPREC = @V_ITEM AND ISNULL(ITEMCOLE.IDPRECALT, 'S') = 'S') OR @V_ITEM = 'T')
                           AND ITEMCOLE.VRPRECUNIITM <> 0
                           AND ITEMCOLE.CDREGIAO = @C_ITEMSOLI_CDREGIAO
                           AND @C_ITEMSOLI_DTPROGENTR BETWEEN ITEMCOLE.DTINIVALITM AND ITEMCOLE.DTFINVALITM
                           AND FORNECEDOR.IDSITUCADA = 'A'
                           AND FORNECEDOR.IDTIPOFORN <> 'A'
                           AND COLETAPR.NRCOMPRA IS NULL
                           AND ((@C_ITEMSOLI_CDMARCA IS NULL) OR (ITEMCOLE.CDMARCA = @C_ITEMSOLI_CDMARCA))
                           AND ((@V_IDUTISTATCOT = 'N') OR (ISNULL(COLETAPR.IDSITUCOLETA, 'C') = 'C'))
                           AND NOT EXISTS (SELECT REFOREG.CDREGIAO
                                             FROM REFOREG
                                            WHERE REFOREG.CDREGIAO = @C_ITEMSOLI_CDREGIAO
                                              AND REFOREG.CDFORNECED = ITEMCOLE.CDFORNECED)
                           AND NOT EXISTS (SELECT QFOPRODFORN.CDPRODUTO
                                             FROM QFOPRODFORN CROSS JOIN PARASUPRI
                                            WHERE PARASUPRI.CDFILIAL = @P_CDCENTCMP
                                              AND QFOPRODFORN.CDPRODUTO = PRODUTO.CDPRODUTO
                                              AND QFOPRODFORN.CDFORNECED= ITEMCOLE.CDFORNECED
                                              AND ((QFOPRODFORN.IDFORNAPROV = 'N' AND QFOPRODFORN.IDFORNAUTOR = 'N') OR ((QFOPRODFORN.IDFORNAPROV = 'S')
                                              AND ((PARASUPRI.IDULTIDTVALQ = 'M' AND COLETAPR.DTCOLEPREC >
                                                  (DATEADD(MONTH, DATEDIFF(MONTH, 0, QFOPRODFORN.DTVALPRFORN) + 1, 0) - 1))
                                                  OR (PARASUPRI.IDULTIDTVALQ = 'D'
                                                  AND COLETAPR.DTCOLEPREC > QFOPRODFORN.DTVALPRFORN)))))
                           AND NOT EXISTS (SELECT QFOMARPROD.CDMARCA
                                             FROM QFOMARPROD CROSS JOIN PARASUPRI
                                            WHERE PARASUPRI.CDFILIAL = @P_CDCENTCMP
                                              AND QFOMARPROD.CDPRODUTO = PRODUTO.CDPRODUTO
                                              AND QFOMARPROD.CDMARCA = ITEMCOLE.CDMARCA
                                              AND ((QFOMARPROD.IDAPRMARPRO = 'N' AND QFOMARPROD.IDAUTMARPRO = 'N') OR
                                                  ((QFOMARPROD.IDAPRMARPRO = 'S') AND
                                                  ((PARASUPRI.IDULTIDTVALQ = 'M' AND
                                                  COLETAPR.DTCOLEPREC > (DATEADD(MONTH, DATEDIFF(MONTH, 0, QFOMARPROD.DTVALAPROVA) + 1, 0) - 1)) OR
                                                  (PARASUPRI.IDULTIDTVALQ = 'D' AND
                                                  COLETAPR.DTCOLEPREC > QFOMARPROD.DTVALAPROVA)))))
                           AND EXISTS (SELECT QFOMARPROD.CDMARCA
                                         FROM QFOMARPROD
                                        WHERE QFOMARPROD.CDPRODUTO = PRODUTO.CDPRODUTO
                                          AND QFOMARPROD.CDMARCA   = ITEMCOLE.CDMARCA
                                        UNION
                                       SELECT PARASUPRI.CDMARCA
                                         FROM PARASUPRI
                                        WHERE PARASUPRI.CDFILIAL = @P_CDCENTCMP
                                          AND (PARASUPRI.IDMARSEMQUA = 'N' OR PARASUPRI.IDMARSEMQUA IS NULL))
                           AND NOT EXISTS (SELECT QUALIFICACAO.CDQUALIF
                                             FROM QUALIFICACAO CROSS JOIN PARASUPRI
                                            WHERE FORNECEDOR.CDQUALIF = QUALIFICACAO.CDQUALIF
                                              AND PARASUPRI.CDFILIAL = @P_CDCENTCMP
                                              AND FORNECEDOR.IDFORNAUTO = 'N'
                                              AND ((QUALIFICACAO.IDPERCOTCMP = '2') OR
                                                  ((PARASUPRI.IDULTIDTVALQ  = 'D' AND COLETAPR.DTCOLEPREC > FORNECEDOR.DTVALQUALIF) OR
                                                  (PARASUPRI.IDULTIDTVALQ = 'M' AND
                                                  COLETAPR.DTCOLEPREC > (DATEADD(MONTH, DATEDIFF(MONTH, 0, FORNECEDOR.DTVALQUALIF) + 1, 0) - 1)))))
                           AND NOT EXISTS (SELECT REFORFIL.CDFILIAL 
                                             FROM REFORFIL
                                            WHERE REFORFIL.CDFILIAL = @C_ITEMSOLI_CDFILSOLI
                                              AND REFORFIL.CDPERIENTR IS NULL
                                              AND REFORFIL.CDFORNECED = ITEMCOLE.CDFORNECED);
                     OPEN C_GRAVA;
                     FETCH NEXT FROM C_GRAVA INTO @C_GRAVA_CDFILIAL, @C_GRAVA_CDPRODUTO, @C_GRAVA_VRFATOCONV,
                                                  @C_GRAVA_NRCOLEPRECO, @C_GRAVA_CDFORNECED, @C_GRAVA_CDREGIAO,
                                                  @C_GRAVA_CDMARCA, @C_GRAVA_CDTIPCOB, @C_GRAVA_CDFORMPGTO,
                                                  @C_GRAVA_IDUTDIAPGCOL, @C_GRAVA_IDTPFOPGTCOL, @C_GRAVA_IDTIPFREITM,
                                                  @C_GRAVA_NRPARCPGTCOL, @C_GRAVA_CDSEGMARCCOL, @C_GRAVA_VRPRECUNIITM,
                                                  @C_GRAVA_VRPERDESITM, @C_GRAVA_NRDIAPGFXCOL, @C_GRAVA_VRPRECECOITM,
                                                  @C_GRAVA_VRPRECOITMPI, @C_GRAVA_IDITMLISPREC, @C_GRAVA_NRSEQPRELIST;

                     WHILE (@@FETCH_STATUS = 0) BEGIN
                        SET @V_CTIMPOSTO = NULL;
                        SET @V_CONCKEY   = NULL;

                        IF @V_IDSEPAFIMP = 'S' BEGIN
                           SELECT @V_CTIMPOSTO = COUNT(1)
                             FROM IMPCOLET
                            WHERE CDFILIAL = @C_GRAVA_CDFILIAL
                              AND NRCOLEPRECO = @C_GRAVA_NRCOLEPRECO
                              AND CDMARCA = @C_GRAVA_CDMARCA
                              AND CDREGIAO = @C_GRAVA_CDREGIAO
                              AND CDFORNECED = @C_GRAVA_CDFORNECED
                              AND CDPRODUTO = @C_GRAVA_CDPRODUTO;

                           IF @V_CTIMPOSTO = 0 BEGIN
                              SET @V_CONCKEY = '?';
                           END
                           ELSE BEGIN
                              IF @V_CTIMPOSTO = 1 BEGIN
                                 SELECT @V_CONCKEY = CDIMPOSTO
                                   FROM IMPCOLET
                                  WHERE CDFILIAL = @C_GRAVA_CDFILIAL
                                    AND NRCOLEPRECO = @C_GRAVA_NRCOLEPRECO
                                    AND CDMARCA = @C_GRAVA_CDMARCA
                                    AND CDREGIAO = @C_GRAVA_CDREGIAO
                                    AND CDFORNECED = @C_GRAVA_CDFORNECED
                                    AND CDPRODUTO = @C_GRAVA_CDPRODUTO
                                  GROUP BY CDIMPOSTO;
                              END
                              ELSE BEGIN
                                 IF @V_CTIMPOSTO > 1 BEGIN
                                    SET @V_CONCKEY = '*';
                                 END;
                              END;
                           END;
                        END;

                        SET @V_EMITENTE = TEKNISA.EMITENTE(@C_ITEMSOLI_CDFILSOLI, @C_GRAVA_CDPRODUTO, @C_GRAVA_CDFORNECED);
                        SET @V_CDEMPRESA = SUBSTRING(@V_EMITENTE, 3, 2);
                        SET @V_CONCKEY = @V_CONCKEY+@C_GRAVA_CDFILIAL + @C_GRAVA_CDFORNECED +SUBSTRING(@V_EMITENTE, 3, 2)+
                                         @C_GRAVA_IDTPFOPGTCOL +
                                         @C_GRAVA_CDTIPCOB     + @C_GRAVA_IDTIPFREITM  +
                                         @C_GRAVA_CDFORMPGTO   + @C_GRAVA_NRPARCPGTCOL +
                                         @C_GRAVA_NRDIAPGFXCOL + @C_GRAVA_IDUTDIAPGCOL +SUBSTRING(@V_EMITENTE, 1, 1);
                        SET @V_IDTIPEMIT = SUBSTRING(@V_EMITENTE, 1, 1);
                        /*SET @V_DSPZOPGTCONC = TEKNISA.CONCAT_PZO_PAGTO(@C_GRAVA_CDFILIAL,   @C_GRAVA_NRCOLEPRECO,
                                                                       @C_GRAVA_CDFORNECED, @C_GRAVA_CDPRODUTO,
                                                                       @C_GRAVA_CDMARCA,    @C_GRAVA_CDREGIAO);*/
                        SET @V_NRPGTCOLCAR = '';
                        SET @V_DSPZOPGTCONC = '';

                        DECLARE C_PZO_PGTO CURSOR FOR
                           SELECT CONVERT(VARCHAR, NRDIASPGTCOL) AS NRPZOPGT, CONVERT(VARCHAR, VRPERCPGTCOL) AS VRPERPGT
                             FROM PZOPGTITMCOL
                            WHERE CDFILIAL    = @C_GRAVA_CDFILIAL
                              AND NRCOLEPRECO = @C_GRAVA_NRCOLEPRECO
                              AND CDFORNECED  = @C_GRAVA_CDFORNECED
                              AND CDPRODUTO   = @C_GRAVA_CDPRODUTO
                              AND CDMARCA     = @C_GRAVA_CDMARCA
                              AND CDREGIAO    = @C_GRAVA_CDREGIAO
                            ORDER BY NRDIASPGTCOL, VRPERCPGTCOL
       
                        OPEN C_PZO_PGTO;
                        FETCH NEXT FROM C_PZO_PGTO INTO @V_PZO_PGTO_NRPZOPGT, @V_PZO_PGTO_VRPERPGT;
                        
                        WHILE (@@FETCH_STATUS = 0) BEGIN
                           SET @V_NRPGTCOLCAR = @V_NRPGTCOLCAR + ISNULL(@V_PZO_PGTO_NRPZOPGT,'') + '*' + ISNULL(@V_PZO_PGTO_VRPERPGT,'') + '_';
                     
                           FETCH NEXT FROM C_PZO_PGTO INTO @V_PZO_PGTO_NRPZOPGT, @V_PZO_PGTO_VRPERPGT;
                        END;
                        CLOSE C_PZO_PGTO;
                        DEALLOCATE C_PZO_PGTO;
                                                                       
                        SET @V_DSPZOPGTCONC  = @V_NRPGTCOLCAR;

                        SELECT @V_VRARREDCMP = CASE MAX(VRARREDCMP) WHEN NULL THEN 0 ELSE MAX(VRARREDCMP) END
                          FROM PRODUTO
                         WHERE CDPRODUTO = @C_GRAVA_CDPRODUTO;

                        SET @V_QTACOMPRAR_AUX = @V_QTACOMPRAR;
                        IF @V_VRARREDCMP > 0 BEGIN
                           IF (((CAST(@V_QTACOMPRAR_AUX AS DOUBLE PRECISION) / @V_VRARREDCMP)  - (ROUND(@V_QTACOMPRAR_AUX / @V_VRARREDCMP, 0, 1))) <> 0) BEGIN
                              SET @V_QTACOMPRAR_AUX = CEILING(CAST(@V_QTACOMPRAR_AUX AS DOUBLE PRECISION) / @V_VRARREDCMP) * @V_VRARREDCMP;
                           END;
                        END;

                        SET @V_IDAFOPERLOG = 'X';
                        SET @V_CDFILIOPELOG = NULL;

                        IF @V_IDUTILCONSSOLIOL = 'N' BEGIN
                           SELECT @V_IDAFOPERLOG = ISNULL(MAX('2'), 'X')
                             FROM PARAMPRODSUP
                            WHERE CDFILIAL = @C_ITEMSOLI_CDFILSOLI
                              AND CDPRODUTO = @C_GRAVA_CDPRODUTO
                              AND CDFILIOPELOG IS NOT NULL;

                           SELECT @V_CDFILIOPELOG = MAX(CDFILIOPELOG)
                             FROM PARAMPRODSUP
                            WHERE CDFILIAL = @C_ITEMSOLI_CDFILSOLI
                              AND CDPRODUTO = @C_GRAVA_CDPRODUTO;
                        END;

                        SET @V_IDPRODWEB = 'N';
                           
                        SELECT @V_IDPRODWEB = ISNULL(MAX(PARAMPRODSUP.IDPRODWEB), 'N')
                          FROM PARAMPRODSUP
                         WHERE CDFILIAL = @C_ITEMSOLI_CDFILSOLI
                           AND CDPRODUTO = @C_GRAVA_CDPRODUTO
                           AND CDFORNECED = @C_GRAVA_CDFORNECED;

                        IF @V_CDFILIOPELOG IS NULL BEGIN
                           SET @V_CDFILIOPELOG = 'OL_NULL';
                        END;

                        INSERT INTO ITMAPURPREC (CDCENTITMAP, NRSEQITMAP, CDFILIAP, DTENTRAPUT,
                                                 CDPRODITMAP, NRCOLEITMAP, CDFORNITMAP, CDREGITMAP,
                                                 CDMARCITMAP, QTSOLACOMP, QTACOMP, CDTIPCOBAP,
                                                 CDEMPRESAAP, CDFORMPGTOAP, IDULTDIAPGTAF, CONCKEYAP,
                                                 IDTPFORPGTAP, IDTIPOEMITAP, IDTIPOFRETAP, NRPARCPGTOAP,
                                                 CDSEGMARCCOL, VRPRECUNIAP, VRPERDESIAP, NRDIAPGFIAP,
                                                 DSPZOPGTCOAP, VRPRECECOAP, VRPRECONPIAP, IDITMLISPRAP,
                                                 NRLISTAITMAP)
                             VALUES (@P_CDCENTCMP, @P_NRSEQAPUR, @C_ITEMSOLI_CDFILSOLI, @C_ITEMSOLI_DTPROGENTR,
                                     @C_GRAVA_CDPRODUTO, @C_GRAVA_NRCOLEPRECO, @C_GRAVA_CDFORNECED, @C_GRAVA_CDREGIAO,
                                     @C_GRAVA_CDMARCA, @V_QTACOMPRAR_AUX, @V_QTACOMPRAR_AUX, @C_GRAVA_CDTIPCOB,
                                     @V_CDEMPRESA, @C_GRAVA_CDFORMPGTO, @C_GRAVA_IDUTDIAPGCOL, @V_CONCKEY+@V_CDFILIOPELOG+@V_IDPRODWEB+@V_IDAFOPERLOG,
                                     @C_GRAVA_IDTPFOPGTCOL, @V_IDTIPEMIT, @C_GRAVA_IDTIPFREITM, @C_GRAVA_NRPARCPGTCOL,
                                     @C_GRAVA_CDSEGMARCCOL, @C_GRAVA_VRPRECUNIITM, @C_GRAVA_VRPERDESITM, @C_GRAVA_NRDIAPGFXCOL,
                                     @V_DSPZOPGTCONC, @C_GRAVA_VRPRECECOITM, @C_GRAVA_VRPRECOITMPI, @C_GRAVA_IDITMLISPREC,
                                     @C_GRAVA_NRSEQPRELIST);

                        IF @@ROWCOUNT > 0 BEGIN
                           SET @P_ROWSAFFECT = 'S';
                        END;

                        FETCH NEXT FROM C_GRAVA INTO @C_GRAVA_CDFILIAL, @C_GRAVA_CDPRODUTO, @C_GRAVA_VRFATOCONV,
                                                     @C_GRAVA_NRCOLEPRECO, @C_GRAVA_CDFORNECED, @C_GRAVA_CDREGIAO,
                                                     @C_GRAVA_CDMARCA, @C_GRAVA_CDTIPCOB, @C_GRAVA_CDFORMPGTO,
                                                     @C_GRAVA_IDUTDIAPGCOL, @C_GRAVA_IDTPFOPGTCOL, @C_GRAVA_IDTIPFREITM,
                                                     @C_GRAVA_NRPARCPGTCOL, @C_GRAVA_CDSEGMARCCOL, @C_GRAVA_VRPRECUNIITM,
                                                     @C_GRAVA_VRPERDESITM, @C_GRAVA_NRDIAPGFXCOL, @C_GRAVA_VRPRECECOITM,
                                                     @C_GRAVA_VRPRECOITMPI, @C_GRAVA_IDITMLISPREC, @C_GRAVA_NRSEQPRELIST;
                     END;
                     CLOSE C_GRAVA;
                     DEALLOCATE C_GRAVA;
                  END;

                  SET @V_QTACOMPRAR = 0;
               END;
            END;
            FETCH NEXT FROM C_ITEMSOLI INTO @C_ITEMSOLI_CDPRODESTO, @C_ITEMSOLI_CDFILSOLI, @C_ITEMSOLI_DTPROGENTR,
                                            @C_ITEMSOLI_CDREGIAO, @C_ITEMSOLI_CDMARCA, @C_ITEMSOLI_QTDEACOMP;
         END;
         CLOSE C_ITEMSOLI;
         DEALLOCATE C_ITEMSOLI;
      END;

      DELETE PRODCMPFILI_TMP
       WHERE NRSEQAPUR = @P_NRSEQAPUR;

      FETCH NEXT FROM C_FILGRUPFILI INTO @C_FILGRUPFILI_CDFILIAL, @C_FILGRUPFILI_IDFUNCAOFILI;
   END;
   CLOSE C_FILGRUPFILI;
   DEALLOCATE C_FILGRUPFILI;

   DECLARE C_ACORDO CURSOR FOR
      SELECT I.CDFILIAP, I.CDPRODITMAP, I.CDCENTITMAP, I.NRCOLEITMAP,
             I.NRSEQITMAP, I.CDREGITMAP, I.CDFORNITMAP, I.DTENTRAPUT, I.CDMARCITMAP
        FROM ITMAPURPREC I INNER JOIN COLETAPR C ON C.CDFILIAL = I.CDCENTITMAP
                                                AND C.NRCOLEPRECO = I.NRCOLEITMAP
       WHERE I.CDCENTITMAP = @P_CDCENTCMP
         AND I.NRSEQITMAP = @P_NRSEQAPUR
         AND C.IDDISMONTLIS = 'N';

   OPEN C_ACORDO;
   FETCH NEXT FROM C_ACORDO INTO @C_ACORDO_CDFILIAP, @C_ACORDO_CDPRODITMAP, @C_ACORDO_CDCENTITMAP, @C_ACORDO_NRCOLEITMAP,
                                 @C_ACORDO_NRSEQITMAP, @C_ACORDO_CDREGITMAP, @C_ACORDO_CDFORNITMAP, @C_ACORDO_DTENTRAPUT,
                                 @C_ACORDO_CDMARCITMAP;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      SET @V_COUNT = 0;

      SELECT @V_COUNT = COUNT(1)
        FROM PARTFILI P
       WHERE @C_ACORDO_CDCENTITMAP = P.CDFILCOTA
         AND @C_ACORDO_NRCOLEITMAP = P.NRCOLEPRECO
         AND @C_ACORDO_CDFILIAP <> P.CDFILIAL
         AND @C_ACORDO_CDPRODITMAP = P.CDPRODUTO
         AND '4' = P.CDTIPPART;

      IF @V_COUNT > 0 BEGIN
         SET @V_COUNT = 0;

         SELECT @V_COUNT = COUNT(1)
           FROM PARTFILI P
          WHERE @C_ACORDO_CDCENTITMAP = P.CDFILCOTA
            AND @C_ACORDO_NRCOLEITMAP = P.NRCOLEPRECO
            AND @C_ACORDO_CDFILIAP = P.CDFILIAL
            AND @C_ACORDO_CDPRODITMAP = P.CDPRODUTO
            AND '4' = P.CDTIPPART;

         IF @V_COUNT <= 0 BEGIN
            DELETE FROM ITMAPURPREC
                  WHERE ITMAPURPREC.CDCENTITMAP  = @C_ACORDO_CDCENTITMAP
                    AND ITMAPURPREC.NRSEQITMAP   = @C_ACORDO_NRSEQITMAP
                    AND ITMAPURPREC.CDREGITMAP   = @C_ACORDO_CDREGITMAP
                    AND ITMAPURPREC.CDFORNITMAP  = @C_ACORDO_CDFORNITMAP
                    AND ITMAPURPREC.NRCOLEITMAP  = @C_ACORDO_NRCOLEITMAP
                    AND ITMAPURPREC.DTENTRAPUT   = @C_ACORDO_DTENTRAPUT
                    AND ITMAPURPREC.CDFILIAP     = @C_ACORDO_CDFILIAP
                    AND ITMAPURPREC.CDPRODITMAP  = @C_ACORDO_CDPRODITMAP
                    AND ITMAPURPREC.CDMARCITMAP  = @C_ACORDO_CDMARCITMAP;
         END;
      END;

      FETCH NEXT FROM C_ACORDO INTO @C_ACORDO_CDFILIAP, @C_ACORDO_CDPRODITMAP, @C_ACORDO_CDCENTITMAP, @C_ACORDO_NRCOLEITMAP,
                                    @C_ACORDO_NRSEQITMAP, @C_ACORDO_CDREGITMAP, @C_ACORDO_CDFORNITMAP, @C_ACORDO_DTENTRAPUT,
                                    @C_ACORDO_CDMARCITMAP;
   END;
   CLOSE C_ACORDO;
   DEALLOCATE C_ACORDO;

   SET @V_COUNT = 0;

   SELECT @V_COUNT = COUNT(1)
     FROM ITMAPURPREC
    WHERE ITMAPURPREC.CDCENTITMAP = @P_CDCENTCMP
      AND ITMAPURPREC.NRSEQITMAP  = @P_NRSEQAPUR;

   IF @V_COUNT > 0 BEGIN
     SET @P_ROWSAFFECT = 'S';
   END
   ELSE BEGIN
     SET @P_ROWSAFFECT = 'N';
   END;

   IF (@P_ROWSAFFECT <> 'S') AND (@P_IDQTFRAC = 'N') BEGIN
      DELETE FROM APURPRECO
            WHERE CDFILCENTCMP = @P_CDCENTCMP
              AND NRAPURPREC   = @P_NRSEQAPUR;
   END;

   DELETE FROM LISTA
         WHERE NRLISTA IN (@V_LISTA_GRUPFILI, @V_LISTA_REGIAO, @V_LISTA_FILIAL);

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'APURA_EFETIVACAO','6.39.017';
GO
