function WebSocketClient(GitQueue, ZHPromise, templateManager, Utilities, requestDataSourceEngine) {
    var self = this;
    this.serverLogs = '';
    this.productPathToDeploy = '';
    this.deployBkpDir = 'deploy_bkp';
    this.deployScriptsDir = 'deploy_scripts';
    this.backupReturned = false;
    this.customizationDowloadPath = 'packageDownload';

    var suffixTmpPath = '_tmp';
    var modulesDirectory = 'modules';
    var modulesTeknisaDirectory = 'teknisa';
    var successDiffPath = 'Diff Success!';
    var requiredCustomizationFiles = ['backend', 'frontend', 'scripts'];
    var customizationDistPath = 'dist';

    var IS_EXEC_SCRIPTS_AUTOMATIC = 'Y';
    var COMPILE_INVALID_OBJECTS_NAME = 'COMPILE_INVALID_OBJECTS';
    var DEFAULT_DATABASE_VERSION_NAME = 'DEFAULT_DATABASE_VERSION';

    this.getDsInDirectory = function(directory) {
        return directory.includes('\\') ? '\\' : '/';
    };
    this.getLibScriptsPath = function(productPath, ds) {
        return productPath + ds + 'backend' + ds + 'vendor' + ds + 'teknisa' + ds + 'libraries' + ds + 'scripts';
    };
    this.getLibNextScriptsPath = function(productPath, ds) {
        return productPath + ds + 'backend' + ds + 'vendor' + ds + 'teknisa' + ds + 'libraries-next' + ds + 'scripts';
    };

    var getLogWidget = function() {
        return templateManager.container.getWidget('LOG');
    };
    var getLogFieldFromLogWidget = function() {
        return getLogWidget().getField('LOG_FIELD');
    };
    var getCurrentRowFromLogWidget = function() {
        return getLogWidget().currentRow;
    };
    var getDeployProdPath = function(baseProdPath, pathToDeploy) {
        return baseProdPath + self.getDsInDirectory(baseProdPath) + pathToDeploy;
    };
    var getDeployTmpPath = function(baseProdPath, pathToDeploy) {
        return getDeployProdPath(baseProdPath, pathToDeploy) + suffixTmpPath;
    };
    this.getCustomizationPackageName = function(customerNrorg, customizationFolder) {
        return 'customizationProduct_' + customerNrorg + '_' + customizationFolder + '.tar.gz';
    };

    //Log Functions
    var setLogScroll = function() {
        var logField = getLogFieldFromLogWidget();
        if(logField && logField.element) {
            var logFieldElement = logField.element[0];
            templateManager.updateTemplate();
            logFieldElement.scrollTop = logFieldElement.scrollHeight;
        }
    };

    var setLogValue = function(data) {
        if(data.value && data.value !== '') {
            var rowLogWidget = getCurrentRowFromLogWidget();
            var value = data.value.trim();
            rowLogWidget.LOG_FIELD_SAVE = rowLogWidget.LOG_FIELD_SAVE + '\n' + value;
            var logValue = rowLogWidget.LOG_FIELD + '\n' + value;
            rowLogWidget.LOG_FIELD = logValue.slice(-5000);
            setLogScroll();

            self.serverLogs = self.serverLogs + '\n' + value;
        }
    };

    var setLogDescription = function(log) {
        var logRow = getCurrentRowFromLogWidget();
        logRow.LOG_FIELD += log;
        logRow.LOG_FIELD_SAVE = logRow.LOG_FIELD_SAVE ? logRow.LOG_FIELD_SAVE + log : log;
        setLogScroll();
    };

    var DESC_LOG_COPY_ACTUAL_VERSION = '\n\n-- Copiando a versão atual do diretório: "%1" --';
    var DESC_LOG_DIFF_COPY = '\n\n-- Verificando a pasta copiada --';
    var DESC_LOG_COPY_ACTUAL_VERSION_NO_BREAK_LINE = '-- Copiando a versão atual do diretório: "%1" --';
    var DESC_LOG_MOVE_BACKUP = '\n\n-- Criando backup --';
    var DESC_LOG_MOVE_TO_DOWNLOAD_PATH = '\n\n-- Movendo arquivo compactado para pasta de download --';
    var DESC_LOG_CREATE_PATH = '\n\n-- Criando diretório: "%1" --';
    var DESC_LOG_WGET = '\n\n-- Baixando arquivo: "%1" --';
    var DESC_LOG_REMOVE_SCRIPTS = '\n\n-- Removendo script --';
    var DESC_LOG_REMOVE_AUX_PATH = '\n\n-- Removendo pasta auxiliar --';
    var DESC_LOG_CREATE_FILE = '\n\n-- Criando arquivo: "%1" --';
    var DESC_LOG_SHEXEC = '\n\n-- Executando script: "%1" --';
    var DESC_LOG_PHPEXEC = '\n\n-- Executando script PHP: "%1" --';
    var DESC_LOG_FILE_EXISTS = '\n\n-- Validando existência do arquivo: "%1" --';
    var DESC_LOG_PRODUCT_PHP_VERSION = '\n\n-- Versão do PHP do Produto/Módulo --';
    var DESC_LOG_REMOVE_PACKAGES = '\n\n-- Removendo pacote --';
    var DESC_LOG_CUSTOMIZATION_PERCENT_COMPLETED = '\nPorcentagem de conclusão: %1';
    var DESC_LOG_GET_MIGRATION_LOG = '\n\n-- Obtendo o log da aplicação do script SQL --';
    var DESC_LOG_CREATING_CUSTOMIZATION_FILE = '\n\n-- Enviando o arquivo compactado para o servidor de aplicação --';
    var DESC_LOG_CREATING_CUSTOMIZATION_FILE_NO_BREAK_LINE = '-- Enviando o arquivo compactado para o servidor de aplicação --';
    var DESC_LOG_MOVE_PRODUCTION = '\n\n-- Aplicando atualizações no diretório de produção --';
    var DESC_LOG_WGET_NO_BREAK_LINE = '-- Baixando arquivo: "%1" --';
    var DESC_LOG_CREATE_FILE_NO_BREAK_LINE = '-- Criando arquivo: "%1" --';
    var DESC_LOG_DECOMPRESS_ARCHIVE = '\n\n-- Extraindo arquivo: "%1" --';
    var DESC_LOG_MOVE_BKP_PROD = '\n\n-- Retornando backup (%1) --';
    var DESC_LOG_MOVE_PROD_TMP = '\n\n-- Criando diretório de produção temporário (%1) --';
    var DESC_LOG_MOVE_TMP_PROD = '\n\n-- Retornando diretório de produção temporário (%1) --';
    var DESC_LOG_REMOVE_TMP_PATH = '\n\n-- Removendo diretório de produção temporário (%1) --';
    var DESC_LOG_REMOVE_BKP_PATH = '\n\n-- Removendo diretório do backup --';
    var DESC_LOG_LS_DEPLOY = '\n\n-- Backups antigos: "%1" --';
    var DESC_LOG_LS = '\n\n-- Lista de diretórios/arquivos --';
    var DESC_LOG_REMOVE_OLD_BACKUP = '\n\n-- Removendo backup antigo: "%1" --';
    var DESC_LOG_FILE_SQL = '\n\n-- Executando script SQL: "%1" (%2) --';
    var DESC_LOG_SCRIPT = '\nScript: %1';
    var DESC_LOG_RESULT = '\nResultado: ';
    var DESC_LOG_SCRIPT_EXEC_SUCCESS = DESC_LOG_RESULT + 'Executado com sucesso!';
    var DESC_LOG_IGNORED_MIGRATION_ERROR = '\nIgnorado!';
    var DESC_LOG_MIGRATION_ERROR = '\n### ERRO ###';
    var DESC_LOG_REPOSITORY = '\n\n-- Repositório: %1 (%2) --';
    var DESC_LOG_MIG_REPOSITORY = '\n>>> Repositório: %1 (%2)';
    var DESC_LOG_MIG_LAST_FILE_NUMBER = '\n>>> Versão atual do banco de dados: %1';
    var DESC_LOG_UPDATE_LAST_MIGRATION = '\n\n-- Atualizando a referência de último script SQL realizado: "%1" (%2) --';

    var DESC_LOG_INIT_MIGRATION      = '\n\n--> INICIANDO O PROCESSO DE ATUALIZAÇÃO DA ESTRUTURA DO BANCO DE DADOS <--';
    var DESC_LOG_END_MIGRATION       = '\n\n--> ATUALIZAÇÃO DA ESTRUTURA DO BANCO DE DADOS FINALIZADA %1 <--';
    var DESC_LOG_END_MIGRATION_EMPTY = '\n\n--> NÃO FORAM IDENTIFICADAS ATUALIZAÇÕES DE ESTRUTURA DO BANCO DE DADOS <--';

    this.connectInServer = function() {
        GitQueue.connect(wsServer);
    };
    this.loginInServer = function(id) {
        return GitQueue.loginBrowser(id);
    };

    this.executePhpScript = function(path, file, room) {
        var defer  = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };
        var resolve = function(sucess) {
            defer.resolve(sucess);
        };

        (room || GitQueue).phpExec(path, file)
            .error(reject)
            .then(resolve);

        return defer.promise;
    };

    this.fileExists = function(path, file, room) {
        var defer  = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };
        var resolve = function(sucess) {
            defer.resolve(sucess);
        };

        (room || GitQueue).fileExists(path, file)
            .error(reject)
            .then(resolve);

        return defer.promise;
    };

    this.cat = function(path, file, room) {
        var defer  = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };
        var resolve = function(sucess) {
            defer.resolve(sucess);
        };

        (room || GitQueue).cat(path, file)
            .error(reject)
            .then(resolve);

        return defer.promise;
    };

    this.downloadPackages = function(packages, prodPath, prodServerId, serverName, room) {
        var defer = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };
        var logWidget = getLogWidget();

        var packagesPromises = packages.map(function (package) {
            return function() {
                var descriptionLog;
                var descWgetNoBreakLine = DESC_LOG_WGET_NO_BREAK_LINE.replace('%1', package.FILE_NAME);
                if(logWidget.currentRow.LOG_FIELD === '' || logWidget.currentRow.LOG_FIELD === undefined) {
                    descriptionLog = descWgetNoBreakLine ;
                } else {
                    descriptionLog = DESC_LOG_WGET.replace('%1', package.FILE_NAME);
                }
                setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                self.serverLogs = (self.serverLogs || '') + descriptionLog;
                return (room || GitQueue).wget(prodPath, package.URL, package.FILE_NAME)
                    .progress(setLogValue)
                    .error(reject);
            };
        });

        Util.doSync(packagesPromises, function () {
            defer.resolve();
        });

        return defer.promise;
    };

    this.decompressPackages = function(packages, baseProdPath, prodServerId, serverName, room) {
        var defer = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };

        var doDecompress = function() {
            var packagesPromises = packages.map(function (package) {
                return function() {
                    if(!self.productPathToDeploy) {
                        self.productPathToDeploy = package.PATH_TO_DEPLOY + suffixTmpPath;
                    }
                    var tmpPath = getDeployTmpPath(baseProdPath, package.PATH_TO_DEPLOY);
                    var descriptionLog = DESC_LOG_CREATE_PATH.replace('%1', tmpPath);
                    setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                    self.serverLogs = self.serverLogs + descriptionLog;
                    return (room || GitQueue).remove(tmpPath)
                        .error(reject)
                        .then(function() {
                            return (room || GitQueue).createPath(tmpPath)
                                .progress(setLogValue)
                                .error(reject)
                                .then(function() {
                                    var file = baseProdPath + self.getDsInDirectory(baseProdPath) + package.FILE_NAME;
                                    var descriptionLog = DESC_LOG_DECOMPRESS_ARCHIVE.replace('%1', package.FILE_NAME);
                                    setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                                    self.serverLogs = self.serverLogs + descriptionLog;
                                    return (room || GitQueue).decompressArchive(tmpPath, file)
                                        .progress(setLogValue)
                                        .error(reject);
                                });
                        });
                };
            });

            Util.doSync(packagesPromises, function () {
                defer.resolve();
            });
        };

        GitQueue.createPath(baseProdPath + self.getDsInDirectory(baseProdPath) + self.deployBkpDir)
            .error(doDecompress)
            .then(doDecompress);

        return defer.promise;
    };

    this.createFilesDeploy = function(files, prodServerId, serverName, room) {
        var filePromises = files.map(function(file) {
            return function() {
                return self.createFileDeploy(file.PATH, file.FILE_NAME, file.TEXT, prodServerId, serverName, room);
            };
        });

        var defer  = ZHPromise.defer();
        Util.doSync(filePromises, function () {
            defer.resolve();
        });
        return defer.promise;
    };
    

    this.createFileDeploy = function(path, fileName, fileContents, prodServerId, serverName, room) {
        var defer  = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };
        var resolve = function () {
            defer.resolve();
        };
        var logWidget = getLogWidget();
        var descriptionLog;
        var descLogNoBreakLine = DESC_LOG_CREATE_FILE_NO_BREAK_LINE.replace('%1', fileName);
        if(logWidget.currentRow.LOG_FIELD === '' || logWidget.currentRow.LOG_FIELD === undefined) {
            descriptionLog = descLogNoBreakLine;
        } else {
            descriptionLog = DESC_LOG_CREATE_FILE.replace('%1', fileName);
        }

        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
        self.serverLogs = self.serverLogs ? self.serverLogs + descriptionLog : descriptionLog;
        (room || GitQueue).createPath(path)
            .error(reject)
            .then(function() {
                (room || GitQueue).createFile(path, fileName, fileContents)
                    .progress(setLogValue)
                    .error(reject)
                    .then(resolve);
            });


        return defer.promise;
    };

    this.executeScriptsDeploy = function(files, prodServerId, serverName, room) {
        var defer = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };
        var resolve = function() {
            defer.resolve();
        };

        var filePromises = files.map(function(file) {
            return function() {
                var deferFile = ZHPromise.defer();
                var rejectFile = function (error) {
                    deferFile.reject(error);
                };
                var resolveFile = function () {
                    deferFile.resolve();
                };
                self.executeShFileDeploy(file.PATH, file.FILE_NAME, prodServerId, serverName, room)
                    .then(resolveFile)
                    .catch(rejectFile);
                return deferFile.promise;
            };
        });

        Utilities.doSyncCP(filePromises)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    this.executeShFileDeploy = function(path, file, prodServerId, serverName, room) {
        var defer  = ZHPromise.defer();
        var reject = function (error) {
            var dataError = error.data;
            dataError = dataError.split('[EXIT_ERROR]');
            if(dataError.length > 1) {
                error.data = dataError[1];
            } else {
                error.data = dataError[0];
            }
            defer.reject(error);
        };
        var resolve = function(sucess) {
            defer.resolve(sucess);
        };
        
        var descriptionLog = DESC_LOG_SHEXEC.replace('%1', file);
        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
        self.serverLogs = self.serverLogs + descriptionLog;
        (room || GitQueue).shExec(path, file)
            .progress(setLogValue)
            .error(reject)
            .then(resolve);

        return defer.promise;
    };

    this.moveDeployPaths = function(packages, baseProdPath, baseProdPathBkp, deployBkpPath, serverName, room) {
        baseProdPathBkp = baseProdPathBkp || baseProdPath;
        var defer = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };
        var backPathToSave;

        var moveTmpToProd = function (tmpPath, prodPath) {
            var descriptionLog = DESC_LOG_MOVE_PRODUCTION;
            setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
            self.serverLogs = self.serverLogs + descriptionLog;
            return (room || GitQueue).move(tmpPath, prodPath)
                .progress(setLogValue)
                .error(reject);
        };
        var packagesPromises = packages.map(function (package) {
            return function() {
                var prodPath = getDeployProdPath(baseProdPath, package.PATH_TO_DEPLOY);
                var tmpPath = getDeployTmpPath(baseProdPath, package.PATH_TO_DEPLOY);
                var ds = self.getDsInDirectory(baseProdPath);
                var bkpDepPath = baseProdPathBkp + ds + self.deployBkpDir + ds + deployBkpPath;
                var bkpPath = bkpDepPath + ds + package.PATH_TO_DEPLOY;
                var pathToDeploy = package.PATH_TO_DEPLOY.split(ds);
                if(pathToDeploy.length > 1) {
                    pathToDeploy.pop();
                    bkpDepPath += ds + pathToDeploy.join(ds);
                }
                backPathToSave = bkpPath;

                var descriptionLog = DESC_LOG_CREATE_PATH.replace('%1', bkpDepPath);
                setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                self.serverLogs = self.serverLogs + descriptionLog;
                return (room || GitQueue).createPath(bkpDepPath)
                    .progress(setLogValue)
                    .error(reject)
                    .then(function() {
                        var descriptionLog = DESC_LOG_MOVE_BACKUP;
                        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                        self.serverLogs = self.serverLogs + descriptionLog;
                        return (room || GitQueue).remove(bkpPath)
                            .move(prodPath, bkpPath)
                            .progress(setLogValue)
                            .error(function(error) {
                                if(error.data.indexOf('rquivo ou diretório') != -1 ||
                                   error.data.indexOf('such file or directory') != -1 ||
                                   error.data.indexOf('pode encontrar o arquivo') != -1 ||
                                   error.data.indexOf('cannot find the file specified') != -1) {
                                    (room || GitQueue).remove(bkpDepPath)
                                        .error(function() {
                                            return moveTmpToProd(tmpPath, prodPath);
                                        })
                                        .then(function() {
                                            return moveTmpToProd(tmpPath, prodPath);
                                        });
                                } else {
                                    reject(error);
                                }
                            })
                            .then(function () {
                                return moveTmpToProd(tmpPath, prodPath);
                            });
                    });
            };
        });

        Util.doSync(packagesPromises, function () {
            defer.resolve(backPathToSave);
        });

        return defer.promise;
    };

    this.removePackagesDeploy = function(packages, prodPath, deployScripts, prodServerId, serverName, room) {
        var defer = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };

        var packagesPromises = packages.map(function (package) {
            return function() {
                var ds = self.getDsInDirectory(prodPath);
                var descriptionLog = DESC_LOG_REMOVE_PACKAGES;
                setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                self.serverLogs = self.serverLogs + descriptionLog;
                return (room || GitQueue).remove(prodPath + ds + package.FILE_NAME + '.tar.gz')
                    .progress(setLogValue)
                    .error(reject);
            };
        });

        Util.doSync(packagesPromises, function () {
            defer.resolve();
        });

        return defer.promise;
    };

    this.removeScriptsDeploy = function(deployScripts, prodServerId, serverName, room) {
        var defer = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };

        var scriptsPromises = deployScripts.map(function (script) {
            return function() {
                var descriptionLog = DESC_LOG_REMOVE_SCRIPTS;
                setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                self.serverLogs = self.serverLogs + descriptionLog;
                return (room || GitQueue).remove(script.PATH)
                    .progress(setLogValue)
                    .error(reject);
            };
        });

        Util.doSync(scriptsPromises, function () {
            defer.resolve();
        });

        return defer.promise;
    };

    this.removeGeneratedDeployPaths = function(serverBasePath, serverName, room) {
        var defer = ZHPromise.defer();
        var resolve = function (success) {
            defer.resolve(success);
        };

        var removeGeneratedPath = function(path) {
            var deferAux = ZHPromise.defer();
            var resolveAux = function (success) {
                deferAux.resolve(success);
            };

            var descriptionLog = DESC_LOG_REMOVE_AUX_PATH;
            var ds = self.getDsInDirectory(serverBasePath);
            setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
            self.serverLogs = self.serverLogs + descriptionLog;
            (room || GitQueue).remove(serverBasePath + ds + path)
                .progress(setLogValue)
                .error(resolveAux)
                .then(resolveAux);

            return deferAux.promise;
        };

        removeGeneratedPath(self.deployScriptsDir)
                .then(resolve)
                .catch(resolve);

        return defer.promise;
    };

    this.copyActualVersion = function(prodPackages, serverBasePath, isModule, serverName, room) {
        var defer = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };
        var resolve = function (success) {
            defer.resolve(success);
        };

        var packagePromises = prodPackages.map(function(prodPackage) {
            return function() {
                var deferPackage = ZHPromise.defer();
                var rejectPackage = function (error) {
                    deferPackage.reject(error);
                };
                var resolvePackage = function (success) {
                    deferPackage.resolve(success);
                };
                var logWidget = getLogWidget();
                var destinyPath = '';
                var ds = self.getDsInDirectory(serverBasePath);
                if(isModule) {
                    destinyPath += serverBasePath + ds + self.productPathToDeploy + ds + modulesDirectory + ds + prodPackage.PATH_TO_DEPLOY;
                } else {
                    destinyPath += serverBasePath + ds + prodPackage.PATH_TO_DEPLOY + suffixTmpPath;
                    if(!self.productPathToDeploy) {
                        self.productPathToDeploy = prodPackage.PATH_TO_DEPLOY + suffixTmpPath;
                    }
                }
                var originPath = destinyPath.replace(suffixTmpPath, '');
                var descriptionLog = DESC_LOG_COPY_ACTUAL_VERSION.replace('%1', originPath);
                if(logWidget.currentRow.LOG_FIELD === '' || logWidget.currentRow.LOG_FIELD === undefined) {
                    descriptionLog = DESC_LOG_COPY_ACTUAL_VERSION_NO_BREAK_LINE.replace('%1', originPath);
                }
                var excludedInCopy = isModule ? [] : [modulesDirectory];
                var pathToCreate   = destinyPath.split(ds).slice(0, -1).join(ds);

                setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                self.serverLogs = self.serverLogs + descriptionLog;
                (room || GitQueue).remove(destinyPath)
                    .createPath(pathToCreate)
                    .copy(originPath, destinyPath, excludedInCopy)
                    .progress(setLogValue)
                    .error(rejectPackage)
                    .then(function() {
                        setLogDescription(DESC_LOG_DIFF_COPY + ' Servidor: ' + serverName + ' --');
                        self.serverLogs = self.serverLogs + DESC_LOG_DIFF_COPY;
                        (room || GitQueue).diffDirectories(originPath, destinyPath, excludedInCopy)
                            .progress(setLogValue)
                            .error(rejectPackage)
                            .then(function(diff) {
                                if(diff.trim() !== '') {
                                    rejectPackage(diff);
                                } else {
                                    setLogValue(successDiffPath);
                                    if (isModule) {
                                        resolvePackage();
                                    } else {
                                        var modulesPath = destinyPath + ds + modulesDirectory + ds + modulesTeknisaDirectory;
                                        var descriptionLog = DESC_LOG_CREATE_PATH.replace('%1', modulesPath);
                                        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                                        self.serverLogs = self.serverLogs + descriptionLog;
                                        (room || GitQueue).createPath(modulesPath)
                                            .progress(setLogValue)
                                            .error(rejectPackage)
                                            .then(resolvePackage);
                                    }
                                }
                            });
                    });

                return deferPackage.promise;
            };
        });

        Utilities.doSyncCP(packagePromises)
            .then(resolve)
            .catch(reject);

        return defer.promise;
    };

    this.removeOldBackups = function(baseProdPath, productId, bkbLimit, prodServerId, serverName, room) {
        var removedPaths = [];
        var ds = self.getDsInDirectory(baseProdPath);
        var bkpDepPath = baseProdPath + ds + self.deployBkpDir;
        var defer = ZHPromise.defer();
        var resolve = function () {
            defer.resolve(removedPaths);
        };

        var deleteDirectories = function(directoriesToDelete) {
            var directoriesPromises = directoriesToDelete.map(function (directory) {
                return function() {
                    var descriptionLog = DESC_LOG_REMOVE_OLD_BACKUP.replace('%1', directory);
                    setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                    self.serverLogs = self.serverLogs + descriptionLog;
                    return (room || GitQueue).remove(bkpDepPath + ds + directory)
                        .progress(setLogValue)
                        .error(resolve)
                        .then(function() {
                            removedPaths.push(directory);
                        });
                };
            });

            Util.doSync(directoriesPromises, resolve);
        };

        var descriptionLog = DESC_LOG_LS_DEPLOY.replace('%1', productId);
        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
        self.serverLogs = self.serverLogs + descriptionLog;
        (room || GitQueue).lsWithFilterDeploy(bkpDepPath, 'PROD_' + productId, bkbLimit)
            .progress(setLogValue)
            .error(resolve)
            .then(deleteDirectories);

        return defer.promise;
    };

    this.moveDeployBkpPaths = function(packages, serverName, baseProdPath, baseProdPathBkp, deployBkpPath, room) {
        baseProdPathBkp = baseProdPathBkp || baseProdPath;
        var bkbNotFound = false;
        var defer = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };

        var packagesPromises = packages.map(function (package) {
            return function() {
                var deferPackage = ZHPromise.defer();
                var resolve = function() {
                    deferPackage.resolve();
                };
                var ds = self.getDsInDirectory(baseProdPath);
                var prodPath = getDeployProdPath(baseProdPath, package.PATH_TO_DEPLOY);
                var tmpPath = getDeployTmpPath(baseProdPath, package.PATH_TO_DEPLOY);
                var bkpDepPath = baseProdPathBkp + ds + self.deployBkpDir + ds + deployBkpPath;
                var bkpPath = bkpDepPath + ds + package.PATH_TO_DEPLOY;

                var descriptionLog = DESC_LOG_MOVE_PROD_TMP.replace('%1', package.NAME);
                setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                self.serverLogs = self.serverLogs + descriptionLog;
                (room || GitQueue).move(prodPath, tmpPath)
                    .progress(setLogValue)
                    .error(reject)
                    .then(function() {
                        var descriptionLog = DESC_LOG_MOVE_BKP_PROD.replace('%1', package.NAME);
                        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                        self.serverLogs = self.serverLogs + descriptionLog;
                        (room || GitQueue).move(bkpPath, prodPath)
                            .progress(setLogValue)
                            .error(function() {
                                bkbNotFound = true;
                                var descriptionLog = DESC_LOG_MOVE_TMP_PROD.replace('%1', package.NAME);
                                setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                                self.serverLogs = self.serverLogs + descriptionLog;
                                (room || GitQueue).move(tmpPath, prodPath)
                                    .progress(setLogValue)
                                    .error(resolve)
                                    .then(resolve);
                            }).then(function() {
                                var descriptionLog = DESC_LOG_REMOVE_TMP_PATH.replace('%1', package.NAME);
                                setLogDescription(descriptionLog + ' Server: ' + serverName + ' --');
                                self.serverLogs = self.serverLogs + descriptionLog;
                                (room || GitQueue).remove(tmpPath)
                                    .progress(setLogValue)
                                    .error(resolve)
                                    .then(resolve);
                            });
                    });

                return deferPackage.promise;
            };
        });

        Util.doSync(packagesPromises, function () {
            defer.resolve(bkbNotFound);
        });

        return defer.promise;
    };

    this.removeDeployBkpPaths = function(serverName, baseProdPath, baseProdPathBkp, deployBkpPath, room) {
        var defer = ZHPromise.defer();
        var resolve = function (success) {
            defer.resolve(success);
        };
        
        baseProdPathBkp = baseProdPathBkp || baseProdPath;
        var ds = self.getDsInDirectory(baseProdPathBkp);
        var bkpDepPath = baseProdPathBkp + ds + self.deployBkpDir + ds + deployBkpPath;
        setLogDescription(DESC_LOG_REMOVE_BKP_PATH + ' Server: ' + serverName + ' --');
        self.serverLogs = self.serverLogs + DESC_LOG_REMOVE_BKP_PATH;
        (room || GitQueue).remove(bkpDepPath)
            .progress(setLogValue)
            .error(resolve)
            .then(resolve);

        return defer.promise;
    };

    this.lsPath = function(path) {
        return GitQueue.ls(path);
    };

    this.createPath = function(path, serverName, room) {
        var defer = ZHPromise.defer();
        var resolve = function () {
            defer.resolve();
        };
        var descriptionLog = DESC_LOG_CREATE_PATH.replace('%1', path);
        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
        self.serverLogs = self.serverLogs + descriptionLog;
        (room || GitQueue).createPath(path)
            .progress(setLogValue)
            .then(resolve)
            .catch(resolve);

        return defer.promise;
    };

    this.getLastAppliedMigration = function(serverBasePath, serverName, repositoriesInfo, currentOrgId, room) {
        var defer = ZHPromise.defer();
        var resolve = function(success) {
            defer.resolve(success);
        };
        var reject = function (error) {
            setLogDescription('\n' + '### Process finished with error.');
            defer.reject(error);
        };

        if(repositoriesInfo.length === 0) {
            resolve(false);
        } else {
            var ds = self.getDsInDirectory(serverBasePath);
            var path = serverBasePath + ds + self.getLibScriptsPath(self.productPathToDeploy, ds);
            var file = 'pendentMigration.php';

            var descriptionLog = DESC_LOG_FILE_EXISTS.replace('%1', file);
            setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
            self.serverLogs = self.serverLogs + descriptionLog;
            (room || GitQueue).fileExists(path, file)
                .progress(setLogValue)
                .error(function () {
                    resolve(false);
                }).then(function (result) {
                    //File exists = true
                    if (result.indexOf('not_found') == -1) {
                        descriptionLog = DESC_LOG_PHPEXEC.replace('%1', file);
                        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                        self.serverLogs = self.serverLogs + descriptionLog;
                        file = file + ' ' + currentOrgId + " '" + JSON.stringify(repositoriesInfo) + "'";
                        (room || GitQueue).phpExec(path, file)
                            .error(function (error) {
                                if(error.data) {
                                    error = error.data;
                                } else if(error.error) {
                                    error = error.error;
                                } else if(error.data && error.data.error) {
                                    error = error.data.error;
                                }
                                setLogDescription('\n' + error);
                                self.serverLogs = self.serverLogs + '\n' + error;
                                reject(error);
                            }).then(function (response) {
                                var jsonParseError = false;
                                try {
                                    response = JSON.parse(response);
                                } catch(e) {
                                    jsonParseError = true;
                                }

                                if(jsonParseError) {
                                    setLogDescription('\n' + response);
                                    self.serverLogs = self.serverLogs + '\n' + response;
                                    reject(response);
                                } else if (response.ERROR) {
                                    setLogDescription('\n' + response.ERROR);
                                    self.serverLogs = self.serverLogs + '\n' + response.ERROR;
                                    reject(response.ERROR);
                                } else {
                                    response.map(function (migration) {
                                        var log = DESC_LOG_MIG_REPOSITORY.replace('%1', migration.REPOSITORY_NAME)
                                                                         .replace('%2', migration.REPOSITORY_URL) +
                                            DESC_LOG_MIG_LAST_FILE_NUMBER.replace('%1', migration.MIG_LAST_FILE_NUMBER);
                                        setLogDescription(log);
                                        self.serverLogs = self.serverLogs + log;
                                    });
                                    resolve(response);
                                }
                            });
                    } else {
                        resolve(false);
                    }
                });
        }

        return defer.promise;
    };

    var migrationHandling = function(error) {
        var ignoredErrors  = migrationIgnoredErrors.split(',');
        var isIgnoredError = false;

        ignoredErrors.forEach(function(ignoredError) {
            if(error.search(ignoredError) !== -1) {
                isIgnoredError = true;
            }
        });

        return isIgnoredError;
    };

    var migrationScriptResult = function(result, fileName, scriptDefer) {
        result = JSON.parse(result);
        var resultLog = '';

        if(result.ERROR) {
            resultLog = DESC_LOG_RESULT + result.ERROR;
            setLogDescription(resultLog);
            self.serverLogs = self.serverLogs + resultLog;

            if(migrationHandling(result.ERROR)) {
                setLogDescription(DESC_LOG_IGNORED_MIGRATION_ERROR);
                self.serverLogs = self.serverLogs + DESC_LOG_IGNORED_MIGRATION_ERROR;
                scriptDefer.resolve();
            } else {
                setLogDescription(DESC_LOG_MIGRATION_ERROR);
                self.serverLogs = self.serverLogs + DESC_LOG_MIGRATION_ERROR;
                scriptDefer.reject({
                    ERROR : result.ERROR,
                    FILE  : fileName
                });
            }
        } else {
            resultLog = DESC_LOG_SCRIPT_EXEC_SUCCESS;
            setLogDescription(resultLog);
            self.serverLogs = self.serverLogs + resultLog;
            scriptDefer.resolve();
        }
    };

    var updateLastMigrationResult = function(result, defer) {
        result = JSON.parse(result);
        var resultLog = '';

        if(result.ERROR) {
            resultLog = DESC_LOG_RESULT + result.ERROR;
            setLogDescription(resultLog);
            self.serverLogs = self.serverLogs + resultLog;
            defer.reject(result.ERROR);
        } else {
            resultLog = DESC_LOG_SCRIPT_EXEC_SUCCESS;
            setLogDescription(resultLog);
            self.serverLogs = self.serverLogs + resultLog;
            defer.resolve();
        }
    };

    var updateLastAppliedMigration = function(serverBasePath, serverName, repositoryURL, fileToUpdate, oldFile,
                                              migRepositoryName, currentOrgId, currentOperatorCode, room, migPendFiles) {
        var defer = ZHPromise.defer();
        var ds    = self.getDsInDirectory(serverBasePath);
        var path  = serverBasePath + ds + self.getLibScriptsPath(self.productPathToDeploy, ds);
        var file  = 'saveLastMigration.php';
        oldFile   = oldFile || 'null';
        file += ' ' + repositoryURL + ' ' + fileToUpdate + ' ' + oldFile + ' ' + currentOrgId + ' ' + currentOperatorCode + " '" + JSON.stringify(migPendFiles) + "'";

        var descriptionLog = DESC_LOG_UPDATE_LAST_MIGRATION.replace('%1', fileToUpdate).replace('%2', migRepositoryName);
        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
        self.serverLogs = self.serverLogs + descriptionLog;

        (room || GitQueue).phpExec(path, file)
            .error(function(error) {
                var resultLog = DESC_LOG_RESULT + error;
                setLogDescription(resultLog);
                self.serverLogs = self.serverLogs + resultLog;
                defer.reject(error);
            }).then(function(result) {
                updateLastMigrationResult(result, defer);
            });

        return defer.promise;
    };

    var runMigrationScriptsSuccess = function(defer, serverBasePath, serverName, migDescription, fileName, migLastFileNumber,
                                              migRepositoryName, currentOrgId, currentOperatorCode, room, migPendFiles) {
        var resolve = function() {
            defer.resolve();
        };
        var reject = function (error) {
            defer.reject(error);
        };

        var delimiter = fileName.includes('_') ? '_' : '.';
        fileName      = fileName.split(delimiter)[0];

        updateLastAppliedMigration(serverBasePath, serverName, migDescription, fileName,
            migLastFileNumber, migRepositoryName, currentOrgId, currentOperatorCode, room, migPendFiles).then(function() {
                resolve();
            }).catch(function(error) {
                error.UPDATE_ERROR = true;
                reject(error);
            });
    };

    var runMigrationScripts = function(scripts, fileName, serverBasePath, serverName, productId, migDescription,
                                       migLastFileNumber, migRepositoryName, currentOrgId, currentOperatorCode, room, migPendFiles) {
        var defer = ZHPromise.defer();

        var scriptsPromises = scripts.map(function (script) {
            return function () {
                var scriptDefer = ZHPromise.defer();

                var ds   = self.getDsInDirectory(serverBasePath);
                var path = serverBasePath + ds + self.getLibScriptsPath(self.productPathToDeploy, ds);
                var file = 'applyMigration.php';

                var descriptionLog = DESC_LOG_FILE_SQL.replace('%1', fileName).replace('%2', migRepositoryName);
                setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                self.serverLogs = self.serverLogs + descriptionLog;

                setLogDescription(DESC_LOG_SCRIPT.replace('%1', script));
                self.serverLogs = self.serverLogs + DESC_LOG_SCRIPT.replace('%1', script);

                file = file + ' "' + script + '" ' + currentOrgId;
                (room || GitQueue).phpExec(path, file)
                    .error(function(error) {
                        var resultLog = DESC_LOG_RESULT + error + DESC_LOG_MIGRATION_ERROR;
                        setLogDescription(resultLog);
                        self.serverLogs = self.serverLogs + resultLog;
                        scriptDefer.reject({
                            ERROR : error,
                            FILE  : fileName
                        });
                    }).then(function(result) {
                        migrationScriptResult(result, fileName, scriptDefer);
                    });

                return scriptDefer.promise;
            };
        });

        Utilities.doSyncCP(scriptsPromises)
            .then(function() {
                if(fileName === COMPILE_INVALID_OBJECTS_NAME || fileName === DEFAULT_DATABASE_VERSION_NAME) {
                    defer.resolve();
                } else {
                    runMigrationScriptsSuccess(defer, serverBasePath, serverName, migDescription, fileName,
                        migLastFileNumber, migRepositoryName, currentOrgId, currentOperatorCode, room, migPendFiles);
                }
            }).catch(function(error) {
                error.UPDATE_ERROR = true;
                defer.reject(error);
            });

        return defer.promise;
    };

    var saveInitialMigrationScript = function(repositoryId, deployId, fileNumber, lastFile) {
        var row ={
            changed: true,
            DEPLOY_ID: deployId,
            REPOSITORY_ID: repositoryId,
            FILE_NUMBER: fileNumber,
            LAST_FILE_NUMBER: lastFile
        };
        return requestDataSourceEngine.setDataSource('/saveInitialMigrationScript', [row]);
    };

    this.applyPendentMigrations = function(migrationInfo, serverBasePath, serverName, productId, execScriptsAutomatic,
                                           migrationQueries, currentOrgId, currentOperatorCode, deployId, room) {
        var defer  = ZHPromise.defer();
        var errors = [];
        var fullScripts = [];
        var scriptsFileToBuild;
        execScriptsAutomatic = execScriptsAutomatic === IS_EXEC_SCRIPTS_AUTOMATIC;

        if(execScriptsAutomatic) {
            setLogDescription(DESC_LOG_INIT_MIGRATION);
            self.serverLogs = self.serverLogs + DESC_LOG_INIT_MIGRATION;
        }

        var migrationPromises = migrationInfo.map(function (migration) {
            return function() {
                var migDefer = ZHPromise.defer();
                var migPendFiles = migration.MIG_PENDENT_FILES || [];

                if(migration.MIG_FILES_CONTENT.length > 0) {
                    scriptsFileToBuild = migration.MIG_FILES_CONTENT;
                    fullScripts.push({
                        NAME  : migration.REPOSITORY_NAME + '.sql',
                        SCRIPT: buildFullScript(scriptsFileToBuild, migration.MIG_LAST_FILE_NUMBER, migration.MIG_HIGHER_FILE_NUMBER,
                            migration.MIG_DESCRIPTION, migrationQueries, currentOrgId, currentOperatorCode, migPendFiles, migration.MIG_USE_DEFAULT_VERSION)
                    });

                    var migrationScriptsPromises = migration.MIG_FILES_CONTENT.map(function(file) {
                        var fileName     = file.FILE_NAME;
                        var fileContents = file.FILE_CONTENTS;

                        return function() {
                            if(execScriptsAutomatic) {
                                return runMigrationScripts(fileContents, fileName, serverBasePath, serverName, productId, migration.MIG_DESCRIPTION,
                                    migration.MIG_LAST_FILE_NUMBER, migration.REPOSITORY_NAME, currentOrgId, currentOperatorCode, room, migPendFiles);
                            } else {
                                return ZHPromise.when();
                            }
                        };
                    });

                    if(execScriptsAutomatic) {
                        if(migration.MIG_USE_DEFAULT_VERSION) {
                            var insertMigration = [];
                            insertMigration.push(function() {
                                var insertScript = getReplacedBaseMigrationQuery(migrationQueries.INSERT, migration.MIG_DESCRIPTION, migration.MIG_LAST_FILE_NUMBER, 
                                    currentOrgId, currentOperatorCode, migPendFiles);
                                return runMigrationScripts([insertScript], DEFAULT_DATABASE_VERSION_NAME, serverBasePath, serverName, productId, migration.MIG_DESCRIPTION,
                                    migration.MIG_LAST_FILE_NUMBER, migration.REPOSITORY_NAME, currentOrgId, currentOperatorCode, room, migPendFiles);
                            });
                            migrationScriptsPromises = insertMigration.concat(migrationScriptsPromises);
                        }

                        var descriptionLog = DESC_LOG_REPOSITORY.replace('%1', migration.REPOSITORY_NAME).replace('%2', migration.REPOSITORY_URL);
                        setLogDescription(descriptionLog);
                        self.serverLogs = self.serverLogs + descriptionLog;

                        //Add call COMPILE_INVALID_OBJECTS_NAME
                        migrationScriptsPromises.push(function() {
                            var script = Utilities.COMPILE_INVALID_OBJECTS.replace('/', '');
                            return runMigrationScripts([script], COMPILE_INVALID_OBJECTS_NAME, serverBasePath, serverName, productId, migration.MIG_DESCRIPTION,
                                migration.MIG_LAST_FILE_NUMBER, migration.REPOSITORY_NAME, currentOrgId, currentOperatorCode, room, migPendFiles);
                        });
                    }

                    Utilities.doSyncCP(migrationScriptsPromises).then(function() {
                        migDefer.resolve();
                    }).catch(function(error) {
                        errors.push(error);
                        migDefer.resolve();
                    });
                } else if(!migration.MIG_LAST_FILE_NUMBER) {
                    scriptsFileToBuild = migration.MIG_FILES_CONTENT;
                    fullScripts.push({
                        NAME  : migration.REPOSITORY_NAME + '.sql',
                        SCRIPT: buildFullScript(scriptsFileToBuild, migration.MIG_LAST_FILE_NUMBER, migration.MIG_HIGHER_FILE_NUMBER,
                            migration.MIG_DESCRIPTION, migrationQueries, currentOrgId, currentOperatorCode, migPendFiles, migration.MIG_USE_DEFAULT_VERSION)
                    });
                    if(execScriptsAutomatic) {
                        updateLastAppliedMigration(serverBasePath, serverName, migration.MIG_DESCRIPTION, migration.MIG_HIGHER_FILE_NUMBER,
                            migration.MIG_LAST_FILE_NUMBER, migration.REPOSITORY_NAME, currentOrgId, currentOperatorCode, room, migPendFiles)
                            .then(function () {
                                migDefer.resolve();
                            }).catch(function (error) {
                                errors.push(error);
                                migDefer.resolve();
                            });
                    } else {
                        migDefer.resolve();
                    }
                } else {
                    migDefer.resolve();
                }

                return migDefer.promise;
            };
        });

        Utilities.doSyncCP(migrationPromises)
            .then(function() {
                applyPendentMigrationsResult(defer, errors, fullScripts, deployId, execScriptsAutomatic);
            }).catch(function(error) {
                errors.push(error);
                applyPendentMigrationsResult(defer, errors, fullScripts, deployId, execScriptsAutomatic);
            });

        return defer.promise;
    };

    var endMigrationProcess = function(defer, errors, execScriptsAutomatic, deployId, savedFileIds, emptyScripts) {
        var result = {
            IS_ERROR: false,
            DEPLOY_ID: deployId,
            EMPTY_SCRIPTS: emptyScripts,
            SAVED_FILE_IDS: savedFileIds,
            EXEC_SCRIPTS_AUTOMATIC: execScriptsAutomatic
        };
        if(errors.length > 0) {
            if(execScriptsAutomatic) {
                setLogDescription(DESC_LOG_END_MIGRATION.replace('%1', 'COM ERROS'));
                self.serverLogs = self.serverLogs + DESC_LOG_END_MIGRATION.replace('%1', 'COM ERROS');
            }
            result.IS_ERROR = true;
        } else {
            if(execScriptsAutomatic) {
                var logDescription = '';
                if(emptyScripts) {
                    logDescription = DESC_LOG_END_MIGRATION_EMPTY;
                } else {
                    logDescription = DESC_LOG_END_MIGRATION.replace('%1', 'COM SUCESSO');
                }
                setLogDescription(logDescription);
                self.serverLogs = self.serverLogs + logDescription;
            }
        }

        defer.resolve(result);
    };

    var applyPendentMigrationsResult = function(defer, errors, fullScripts, deployId, execScriptsAutomatic) {
        var savedFileIds = [];
        if(fullScripts.length > 0) {
            fullScripts.map(function (script) {
                script.SCRIPT = addCompileInvalidObjectsEndScript(script.SCRIPT);
                return script;
            });
            var params = [
                {
                    changed: true,
                    deployId: deployId,
                    DOCUMENT : fullScripts,
                    TYPE : "application/sql"
                }
            ];
            requestDataSourceEngine.setDataSource('/saveMigrationScript', params).then(function (response) {
                if(response.dataset) {
                    savedFileIds = response.dataset.savedFiles;
                }
                endMigrationProcess(defer, errors, execScriptsAutomatic, deployId, savedFileIds, false);
            }).catch(function (error) {
                errors.push(error);
                endMigrationProcess(defer, errors, execScriptsAutomatic, deployId, savedFileIds, false);
            });
        } else {
            endMigrationProcess(defer, errors, execScriptsAutomatic, deployId, savedFileIds, true);
        }
    };

    var getReplacedBaseMigrationQuery = function(migScript, migDescription, fileNumber, currentOrgId, currentOperatorCode, migPendFiles) {
        return migScript.replace(':NMOBJETOBD', "'" + migDescription + "'")
            .replace(':NRVEROBJBD', "'" + fileNumber + "'").replace(':NRVEROBJBD', "'" + fileNumber + "'").replace(':DSARQPENDMIG', "'" + JSON.stringify(migPendFiles) + "'")
            .replace(':NRORG', currentOrgId).replace(':NRORG', currentOrgId).replace(':CDOPERADOR', "'" + currentOperatorCode + "'");
    };

    var buildFullScript = function(files, lastFile, higherFile, migDescription, migrationQueries, currentOrgId, currentOperatorCode, migPendFiles, isEmptyDataBase) {
        var fullScript = '';
        var migScript = '';

        if(files.length === 0) {
            if (!lastFile) {
                migScript = migrationQueries.INSERT;
            } else {
                migScript = migrationQueries.UPDATE;
            }
            var fileToUpdate = lastFile || higherFile;
            fullScript += getReplacedBaseMigrationQuery(migScript, migDescription, fileToUpdate, currentOrgId, currentOperatorCode, migPendFiles) + '\n/';
        } else {
            files.forEach(function (file) {
                var fileName     = file.FILE_NAME;
                var fileContents = file.FILE_CONTENTS;
                var isPendFile   = file.IS_PEND_FILE || false;
                var delimiter    = fileName.includes('_') ? '_' : '.';
                var fileNumber   = fileName.split(delimiter)[0];

                if (isEmptyDataBase && fullScript === '') {
                    migScript = migrationQueries.INSERT;
                } else if (isPendFile) {
                    migScript = migrationQueries.PENDENT_FILE;
                } else {
                    migScript = migrationQueries.UPDATE;
                }

                migScript = getReplacedBaseMigrationQuery(migScript, migDescription, fileNumber, currentOrgId, currentOperatorCode, migPendFiles);

                var script = '-- Arquivo: ' + fileName + '\n' + fileContents.join('\n/\n') + '\n/\n' + migScript + '\n/';
                fullScript += fullScript === '' ? script : '\n\n' + script;
            });
        }

        return fullScript;
    };

    var addCompileInvalidObjectsEndScript = function(script) {
        return script + Utilities.COMMIT + Utilities.COMPILE_INVALID_OBJECTS;
    };

    this.removePath = function(path, room) {
        var defer = ZHPromise.defer();
        var resolve = function() {
            defer.resolve();
        };

        (room || GitQueue).remove(path)
            .error(resolve)
            .then(resolve);

        return defer.promise;
    };

    this.createNotFoundFile = function(path, room, fileName, fileContents) {
        var defer = ZHPromise.defer();
        var resolve = function() {
            defer.resolve();
        };

        (room || GitQueue).createFile(path, fileName, fileContents)
            .error(resolve)
            .then(resolve);

        return defer.promise;
    };

    this.createDir = function(path, room) {
        var defer = ZHPromise.defer();
        var resolve = function () {
            defer.resolve();
        };

        (room || GitQueue).createPath(path)
            .then(resolve)
            .catch(resolve);

        return defer.promise;
    };
    
    this.validatePhpVersionForDeploy = function (baseProdPath, prodServerId, serverName, packages, productModule, isModule, room) {
        var defer   = ZHPromise.defer();
        var resolve = function (success) { defer.resolve(success); };
        var reject  = function(error)    { defer.reject(error);    };
        
        var fileContentComand = "php -r '$major = PHP_MAJOR_VERSION; $minor = PHP_MINOR_VERSION; $release = PHP_RELEASE_VERSION;";
        var filecontentVariable = 'echo "$major.$minor.$release";';
        var fileContents = fileContentComand + filecontentVariable + "'";
        
        var fileName = 'phpversion.sh';
        var fileNameComposer = 'composer.json';
        var path, serverMajorPhpVersion, productMajorPhpVersion, serverFullPhpVersion, productFullPhpVersion;
        
        var validateVersions = function(pkgDefer, fullPath) {
            var pkgResolve = function (success) { pkgDefer.resolve(success); };
            var pkgReject  = function(error)    { pkgDefer.reject(error);    };
                
            GitQueue.validateExecuteInWindows().then(function (response) {
                path = getTempFolderPath(response);
                return self.createFileDeploy(path, fileName, fileContents, prodServerId, serverName, room);
            }).then(function() {
                return self.executeShFileDeploy(path, fileName, prodServerId, serverName, room);
            }).then(function(phpVersion) {
                serverFullPhpVersion  = phpVersion;
                serverMajorPhpVersion = serverFullPhpVersion.substr(0, 1);
                return self.cat(fullPath, fileNameComposer, room);
            }).then(function(response) {
                var composerJson       = JSON.parse(response);
                productFullPhpVersion  = composerJson.require.php.replace(/([^\d|.])+/g, '');
                productMajorPhpVersion = productFullPhpVersion.substr(0, 1);
                
                var descriptionLog = DESC_LOG_PRODUCT_PHP_VERSION;
                setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                self.serverLogs = self.serverLogs + descriptionLog;
                setLogDescription('\n' + productFullPhpVersion);
                self.serverLogs = self.serverLogs + '\n' + productFullPhpVersion;
                
                if(productMajorPhpVersion != serverMajorPhpVersion) {
                    var error = {
                        differentPhpVersion : true,
                        productPhpVersion   : productFullPhpVersion,
                        serverPhpVersion    : serverFullPhpVersion,
                        isModule            : isModule,
                        productModuleName   : productModule.NAME
                    };
                    pkgReject(error);
                } else {
                    pkgResolve();
                }
            }).then(pkgResolve).catch(pkgReject);
        };
        
        var packagesPromises = packages.map(function (package) {
            return function() {
                var pkgDefer = ZHPromise.defer();
                var fullPath = package.PATH + '/backend/vendor/zeedhi/framework';
                var descriptionLog = DESC_LOG_FILE_EXISTS.replace('%1', fileNameComposer);
                setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                self.serverLogs = self.serverLogs + descriptionLog;
                
                self.fileExists(fullPath, fileNameComposer, room).then(function (fileExists) {
                    setLogDescription('\n' + fileExists.trim());
                    self.serverLogs = self.serverLogs + '\n' + fileExists.trim();
                    if(fileExists.trim() == "found") {
                        validateVersions(pkgDefer, fullPath);
                    } else {
                        pkgDefer.resolve();
                    }
                }).catch(function() {
                    pkgDefer.resolve();
                });
                
                return pkgDefer.promise;
            };
        });

        Utilities.doSyncCP(packagesPromises)
            .then(resolve)
            .catch(reject);
        
        return defer.promise;
    };
    
    var getTempFolderPath = function(isWindows) {
        if (isWindows) {
            return 'C:\\windows\\Temp';
        }
        return '/tmp';
    };

    this.downloadCustomizationPackage = function(url, baseProdPath, serverName, customizationBaseFolder, customizationFolder) {
        var defer = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };
        var resolve = function (data) {
            defer.resolve(data);
        };
        
        var logWidget = getLogWidget();
        var descriptionLog;
        var descWgetNoBreakLine = DESC_LOG_WGET_NO_BREAK_LINE.replace('%1', url);
        if(logWidget.currentRow.LOG_FIELD === '' || logWidget.currentRow.LOG_FIELD === undefined) {
            descriptionLog = descWgetNoBreakLine ;
        } else {
            descriptionLog = DESC_LOG_WGET.replace('%1', url);
        }

        var ds = self.getDsInDirectory(baseProdPath);
        var prodPath = baseProdPath + ds + customizationBaseFolder;

        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
        self.serverLogs = (self.serverLogs || '') + descriptionLog;
        GitQueue.createPath(prodPath)
            .wget(prodPath, url, customizationFolder)
            .progress(setLogValue)
            .error(reject)
            .then(resolve);

        return defer.promise;
    };

    this.createCustomizationPackage = function(content, baseProdPath, serverName, customizationBaseFolder, customizationFolder) {
        var defer = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };
        var resolve = function (data) {
            defer.resolve(data);
        };

        var createFile = function(lastPosSended, contentLength, actualBufferPercent) {
            var bufferLength  = 100000;
            var actualBuffer  = lastPosSended === 0 ? bufferLength : lastPosSended + bufferLength;
            var bufferPercent = (actualBuffer / contentLength) * 100;
            bufferPercent = bufferPercent > 100 ? 100 : parseInt(bufferPercent.toFixed());
            var toFile = lastPosSended === 0 ? ' > ' : ' >> ';
            var initCommand = 'cd ' + prodPath + ' && echo ';
            var endCommand = ' | base64 --decode' + toFile + customizationFolder + '.tar.gz';
            var command = initCommand + content.substr(lastPosSended, bufferLength) + endCommand;

            return GitQueue.runCommand(command)
                .error(reject)
                .then(function() {
                    if(actualBufferPercent < bufferPercent) {
                        var descriptionLog = DESC_LOG_CUSTOMIZATION_PERCENT_COMPLETED.replace('%1', bufferPercent) + '%';
                        setLogDescription(descriptionLog);
                        self.serverLogs = self.serverLogs + descriptionLog;
                        actualBufferPercent = bufferPercent;
                    }
                    if(lastPosSended >= contentLength) {
                        resolve();
                    } else {
                        return createFile(lastPosSended + bufferLength, contentLength, actualBufferPercent);
                    }
                });
        };

        var ds = self.getDsInDirectory(baseProdPath);
        var prodPath = baseProdPath + ds + customizationBaseFolder;

        var logWidget = getLogWidget();
        var descriptionLog = DESC_LOG_CREATING_CUSTOMIZATION_FILE;
        if(logWidget.currentRow.LOG_FIELD === '' || logWidget.currentRow.LOG_FIELD === undefined) {
            descriptionLog = DESC_LOG_CREATING_CUSTOMIZATION_FILE_NO_BREAK_LINE;
        }
        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
        self.serverLogs = (self.serverLogs || '') + descriptionLog;

        GitQueue.createPath(prodPath)
            .error(function() {
                createFile(0, content.length, 0);
            }).then(function() {
                createFile(0, content.length, 0);
            });

        return defer.promise;
    };

    this.decompressCustomizationPackage = function(prodPath, serverName, fullCustomizationFolder, customizationFolder, customerNrorg) {
        var defer = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };
        var resolve = function (data) {
            defer.resolve(data);
        };

        var ds = self.getDsInDirectory(prodPath);
        var tmpPath = prodPath + ds + fullCustomizationFolder + '_tmp';
        var file = prodPath + ds + fullCustomizationFolder;
        var downloadPath = tmpPath + ds + self.customizationDowloadPath;

        var descriptionLog = DESC_LOG_CREATE_PATH.replace('%1', tmpPath);
        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
        self.serverLogs = self.serverLogs + descriptionLog;
        GitQueue.remove(tmpPath)
            .error(reject)
            .then(function() {
                GitQueue.createPath(tmpPath)
                    .progress(setLogValue)
                    .error(reject)
                    .then(function() {
                        var descriptionLog = DESC_LOG_DECOMPRESS_ARCHIVE.replace('%1', customizationFolder + '.tar.gz');
                        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                        self.serverLogs = self.serverLogs + descriptionLog;
                        GitQueue.decompressArchive(tmpPath, file)
                            .progress(setLogValue)
                            .error(reject)
                            .then(function() {
                                var descriptionLog = DESC_LOG_CREATE_PATH.replace('%1', downloadPath);
                                setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                                self.serverLogs = self.serverLogs + descriptionLog;
                                GitQueue.createPath(downloadPath)
                                    .progress(setLogValue)
                                    .error(reject)
                                    .then(function() {
                                        var packageName = self.getCustomizationPackageName(customerNrorg, customizationFolder);
                                        var downloadFile = downloadPath + ds + packageName;
                                        var descriptionLog = DESC_LOG_MOVE_TO_DOWNLOAD_PATH;
                                        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                                        self.serverLogs = self.serverLogs + descriptionLog;
                                        GitQueue.move(file + '.tar.gz', downloadFile)
                                            .progress(setLogValue)
                                            .error(reject)
                                            .then(resolve);
                                    });
                            });
                    });
            });

        return defer.promise;
    };

    this.moveCustomizationPaths = function(baseProdPath, serverName, fullCustomizationFolder) {
        var defer = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };
        var resolve = function (data) {
            defer.resolve(data);
        };

        var moveTmpToProd = function (tmpPath, prodPath) {
            var descriptionLog = DESC_LOG_MOVE_PRODUCTION;
            setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
            self.serverLogs = self.serverLogs + descriptionLog;
            GitQueue.move(tmpPath, prodPath)
                .progress(setLogValue)
                .error(reject)
                .then(resolve);
        };

        var ds = self.getDsInDirectory(baseProdPath);
        var prodPath = baseProdPath + ds + fullCustomizationFolder;
        var tmpPath  = prodPath + '_tmp';
        var bkpPath  = prodPath + '_bkb';

        var descriptionLog = DESC_LOG_MOVE_BACKUP;
        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
        self.serverLogs = self.serverLogs + descriptionLog;
        GitQueue.remove(bkpPath)
            .move(prodPath, bkpPath)
            .progress(setLogValue)
            .error(function(error) {
                if(error.data.indexOf('rquivo ou diretório') != -1 ||
                   error.data.indexOf('such file or directory') != -1 ||
                   error.data.indexOf('pode encontrar o arquivo') != -1 ||
                   error.data.indexOf('cannot find the file specified') != -1) {
                    moveTmpToProd(tmpPath, prodPath);
                } else {
                    reject(error);
                }
            }).then(function () {
                moveTmpToProd(tmpPath, prodPath);
            });

        return defer.promise;
    };

    this.validateCustomizationPaths = function(baseProdPath, serverName, fullCustomizationFolder) {
        var defer = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };
        var resolve = function (data) {
            defer.resolve(data);
        };

        var ds = self.getDsInDirectory(baseProdPath);
        var tmpPath = baseProdPath + ds + fullCustomizationFolder + '_tmp';
        var frontendPath = baseProdPath + ds + fullCustomizationFolder + '_tmp' + ds + 'frontend';

        setLogDescription(DESC_LOG_LS + ' Servidor: ' + serverName + ' --');
        self.serverLogs = self.serverLogs + DESC_LOG_LS;
        GitQueue.ls(tmpPath)
            .progress(setLogValue)
            .error(reject)
            .then(function (result) {
                var actualFiles = result.split('\n');
                var requiredFiles = requiredCustomizationFiles.filter(function(file) {
                    return !actualFiles.includes(file);
                });
                if(requiredFiles.length) {
                    reject({
                        type: 'REQUIRED_FILES',
                        data: requiredFiles.join('", "')
                    });
                } else {
                    setLogDescription(DESC_LOG_LS + ' Servidor: ' + serverName + ' --');
                    self.serverLogs = self.serverLogs + DESC_LOG_LS;
                    GitQueue.ls(frontendPath)
                        .progress(setLogValue)
                        .error(reject)
                        .then(function (result) {
                            var actualFiles = result.split('\n');
                            var existsDistPath = actualFiles.find(function(item) {
                                return item.trim() == customizationDistPath;
                            });
                            if(!existsDistPath) {
                                reject({
                                    type: 'REQUIRED_FILES',
                                    data: 'frontend' + ds + customizationDistPath
                                });
                            } else {
                                resolve();
                            }
                        });
                }
            });

        return defer.promise;
    };

    this.moveDeployBkpPathsCustomization = function(baseProdPath, serverName, fullCustomizationFolder) {
        var bkbNotFound = false;
        var defer = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };
        var resolve = function () {
            defer.resolve(bkbNotFound);
        };
        
        var ds = self.getDsInDirectory(baseProdPath);
        var prodPath = baseProdPath + ds + fullCustomizationFolder;
        var tmpPath  = prodPath + '_tmp';
        var bkpPath  = prodPath + '_bkb';

        var descriptionLog = DESC_LOG_MOVE_PROD_TMP.replace('%1', prodPath).replace('\n\n', '');
        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
        self.serverLogs = self.serverLogs + descriptionLog;
        GitQueue.move(prodPath, tmpPath)
            .progress(setLogValue)
            .error(reject)
            .then(function() {
                var descriptionLog = DESC_LOG_MOVE_BKP_PROD.replace('%1', bkpPath);
                setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                self.serverLogs = self.serverLogs + descriptionLog;
                GitQueue.move(bkpPath, prodPath)
                    .progress(setLogValue)
                    .error(function() {
                        bkbNotFound = true;
                        var descriptionLog = DESC_LOG_MOVE_TMP_PROD.replace('%1', tmpPath);
                        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                        self.serverLogs = self.serverLogs + descriptionLog;
                        GitQueue.move(tmpPath, prodPath)
                            .progress(setLogValue)
                            .error(resolve)
                            .then(resolve);
                    }).then(function() {
                        var descriptionLog = DESC_LOG_REMOVE_TMP_PATH.replace('%1', tmpPath);
                        setLogDescription(descriptionLog + ' Server: ' + serverName + ' --');
                        self.serverLogs = self.serverLogs + descriptionLog;
                        GitQueue.remove(tmpPath)
                            .progress(setLogValue)
                            .error(resolve)
                            .then(resolve);
                    });
            });

        return defer.promise;
    };

    this.getCustomizationMigration = function(baseProdPath, serverName, customizationTmpFolder, version) {
        var defer = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };
        var resolve = function (data) {
            defer.resolve(data);
        };

        var ds = self.getDsInDirectory(baseProdPath);
        var path = baseProdPath + ds + customizationTmpFolder + ds + 'scripts';

        var dbScriptFileName = version + '.sql';
        var descriptionLog = DESC_LOG_FILE_EXISTS.replace('%1', dbScriptFileName);
        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
        self.serverLogs = self.serverLogs + descriptionLog;
        GitQueue.fileExists(path, dbScriptFileName)
            .progress(setLogValue)
            .error(reject)
            .then(function (result) {
                //File exists = true
                if (result.indexOf('not_found') == -1) {
                    GitQueue.cat(path, dbScriptFileName)
                        .error(reject)
                        .then(function (result) {
                            resolve(result.trim());
                        });
                } else {
                    resolve(false);
                }
            });

        return defer.promise;
    };

    this.getProductionParameters = function(baseProdPath, serverName, customizationTmpFolder) {
        var defer = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };
        var resolve = function (data) {
            defer.resolve(data);
        };

        var ds = self.getDsInDirectory(baseProdPath);
        var baseEnvironmentPath = 'backend/config/environment';
        var path = baseProdPath + ds + customizationTmpFolder + ds + baseEnvironmentPath;
        var file = 'prodEnvironment.json';

        var descriptionLog = DESC_LOG_FILE_EXISTS.replace('%1', file);
        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
        self.serverLogs = self.serverLogs + descriptionLog;
        GitQueue.fileExists(path, file)
            .progress(setLogValue)
            .error(reject)
            .then(function (result) {
                //File exists = true
                if (result.indexOf('not_found') == -1) {
                    GitQueue.cat(path, file)
                        .error(reject)
                        .then(function (result) {
                            resolve(JSON.parse(result.trim()));
                        });
                } else {
                    reject({
                        type: 'PROD_FILE_NOT_FOUND',
                        data: baseEnvironmentPath + ds + file
                    });
                }
            });

        return defer.promise;
    };

    this.executeDbScript = function(baseProdPath, serverName, customizationTmpFolder, params, version) {
        var defer = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };
        var resolve = function (data) {
            defer.resolve(data);
        };

        var ds = self.getDsInDirectory(baseProdPath);
        var path = baseProdPath + ds + customizationTmpFolder + ds + 'scripts';
        var execFile = 'executeScript.sh';

        var descriptionLog = DESC_LOG_FILE_EXISTS.replace('%1', execFile);
        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
        self.serverLogs = self.serverLogs + descriptionLog;
        GitQueue.fileExists(path, execFile)
            .progress(setLogValue)
            .error(reject)
            .then(function (result) {
                //File exists = true
                if (result.indexOf('not_found') == -1) {
                    // Basic connection
                    var dbParams = ' -dir ' + params.DB_ORA_USER + ' '  + 
                                              params.DB_ORA_PASSWORD + ' ' + 
                                              params.DB_ORA_HOST + ' ' + 
                                              params.DB_ORA_PORT + ' ' + 
                                              params.DB_ORA_DBNAME;
                    if(params.DB_ORA_SESSION_MODE) {
                        // Wallet connection
                        dbParams = ' -wal ' + params.DB_ORA_DBNAME;
                    } else if(!params.DB_ORA_HOST && !params.DB_ORA_PORT) {
                        // TNS connection
                        dbParams = ' -tns ' + params.DB_ORA_USER + ' '  + 
                                              params.DB_ORA_PASSWORD + ' ' + 
                                              params.DB_ORA_DBNAME;
                    }
                    var dirParam = ' -d ' + path;
                    var fileParam = ' -f ' + version + '.sql';
                    var fileToExecute = execFile + dirParam + dbParams + fileParam;

                    var descriptionLog = DESC_LOG_SHEXEC.replace('%1', execFile);
                    setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
                    self.serverLogs = self.serverLogs + descriptionLog;
                    GitQueue.shExec(path, fileToExecute)
                        .error(function(error) {
                            reject({
                                type: 'ERROR_EXECUTE_SQL_SCRIPT',
                                data: error
                            });
                        }).progress(setLogValue)
                        .then(function () {
                            resolve();
                        });
                } else {
                    reject({
                        type: 'EXEC_FILE_NOT_FOUND',
                        data: execFile
                    });
                }
            });

        return defer.promise;
    };

    this.getMigrationLog = function(baseProdPath, serverName, customizationTmpFolder, version) {
        var defer = ZHPromise.defer();
        var reject = function (error) {
            defer.reject(error);
        };
        var resolve = function (data) {
            defer.resolve(data);
        };

        var ds = self.getDsInDirectory(baseProdPath);
        var path = baseProdPath + ds + customizationTmpFolder + ds + 'scripts';
        var result = { fullLog: '', errorLog: '' };
        var fullLogFileName = 'log_completo_' + version + '.log';
        var errorLogFileName = 'log_completo_' + version + '_erros.log';

        var descriptionLog = DESC_LOG_GET_MIGRATION_LOG;
        setLogDescription(descriptionLog + ' Servidor: ' + serverName + ' --');
        self.serverLogs = self.serverLogs + descriptionLog;
        GitQueue.cat(path, fullLogFileName)
            .error(reject)
            .then(function (fullLogStr) {
                result.fullLog = fullLogStr.trim();
                GitQueue.cat(path, errorLogFileName)
                    .error(reject)
                    .then(function (errorLogStr) {
                        result.errorLog = errorLogStr.trim();
                        resolve(result);
                    });
            });

        return defer.promise;
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('WebSocketClient', WebSocketClient);
});

